=== modified file 'drizzled/Makefile.am'
--- drizzled/Makefile.am	2009-07-28 20:12:26 +0000
+++ drizzled/Makefile.am	2009-07-29 06:03:18 +0000
@@ -302,7 +302,6 @@
 		session.h \
 		set_var.h \
 		show.h \
-		semi_join_table.h \
 		sql_alloc.h \
 		sql_array.h \
 		sql_base.h \
@@ -577,7 +576,6 @@
 		session.cc \
 		set_var.cc \
 		show.cc \
-		semi_join_table.cc \
 		sql_base.cc \
 		sql_connect.cc \
 		sql_delete.cc \

=== modified file 'drizzled/drizzled.cc'
--- drizzled/drizzled.cc	2009-07-28 23:44:32 +0000
+++ drizzled/drizzled.cc	2009-07-29 07:11:15 +0000
@@ -1177,7 +1177,6 @@
   {"show_fields",          (char*) offsetof(STATUS_VAR, com_stat[(uint32_t) SQLCOM_SHOW_FIELDS]), SHOW_LONG_STATUS},
   {"show_keys",            (char*) offsetof(STATUS_VAR, com_stat[(uint32_t) SQLCOM_SHOW_KEYS]), SHOW_LONG_STATUS},
   {"show_open_tables",     (char*) offsetof(STATUS_VAR, com_stat[(uint32_t) SQLCOM_SHOW_OPEN_TABLES]), SHOW_LONG_STATUS},
-  {"show_plugins",         (char*) offsetof(STATUS_VAR, com_stat[(uint32_t) SQLCOM_SHOW_PLUGINS]), SHOW_LONG_STATUS},
   {"show_processlist",     (char*) offsetof(STATUS_VAR, com_stat[(uint32_t) SQLCOM_SHOW_PROCESSLIST]), SHOW_LONG_STATUS},
   {"show_status",          (char*) offsetof(STATUS_VAR, com_stat[(uint32_t) SQLCOM_SHOW_STATUS]), SHOW_LONG_STATUS},
   {"show_table_status",    (char*) offsetof(STATUS_VAR, com_stat[(uint32_t) SQLCOM_SHOW_TABLE_STATUS]), SHOW_LONG_STATUS},

=== modified file 'drizzled/enum.h'
--- drizzled/enum.h	2009-07-11 06:02:55 +0000
+++ drizzled/enum.h	2009-07-29 07:11:15 +0000
@@ -92,7 +92,8 @@
   IN_HAVING, 
   SELECT_LIST, 
   IN_WHERE, 
-  IN_ON };
+  IN_ON 
+};
 
 enum enum_mysql_completiontype 
 {
@@ -356,8 +357,6 @@
   SQLCOM_COMMIT, 
   SQLCOM_SAVEPOINT, 
   SQLCOM_RELEASE_SAVEPOINT,
-  SQLCOM_SLAVE_START, 
-  SQLCOM_SLAVE_STOP,
   SQLCOM_BEGIN,
   SQLCOM_RENAME_TABLE,
   SQLCOM_SHOW_OPEN_TABLES,
@@ -367,7 +366,6 @@
   SQLCOM_EMPTY_QUERY,
   SQLCOM_SHOW_ERRORS,
   SQLCOM_CHECKSUM,
-  SQLCOM_SHOW_PLUGINS,
   /*
     When a command is added here, be sure it's also added in mysqld.cc
     in "struct show_var_st status_vars[]= {" ...

=== modified file 'drizzled/item/subselect.cc'
--- drizzled/item/subselect.cc	2009-07-09 21:14:05 +0000
+++ drizzled/item/subselect.cc	2009-07-28 17:52:18 +0000
@@ -2134,11 +2134,6 @@
     Select_Lex_Unit *unit= select_lex->master_unit();
 
     unit->set_limit(unit->global_parameters);
-    if (join->flatten_subqueries())
-    {
-      session->is_fatal_error= true;
-      return(1);
-    }
     if (join->optimize())
     {
       session->where= save_where;

=== modified file 'drizzled/join.cc'
--- drizzled/join.cc	2009-07-11 19:23:04 +0000
+++ drizzled/join.cc	2009-07-28 23:50:18 +0000
@@ -28,7 +28,6 @@
  */
 
 #include "drizzled/server_includes.h"
-#include "drizzled/semi_join_table.h"
 #include "drizzled/table_map_iterator.h"
 #include "drizzled/item/cache.h"
 #include "drizzled/item/cmpfunc.h"
@@ -94,7 +93,7 @@
                             uint64_t select_options,
                             const char *info,
                             Item *having);
-static COND *simplify_joins(JOIN *join, List<TableList> *join_list, COND *conds, bool top, bool in_sj);
+static COND *simplify_joins(JOIN *join, List<TableList> *join_list, COND *conds, bool top);
 static int remove_duplicates(JOIN *join,Table *entry,List<Item> &fields, Item *having);
 static int setup_without_group(Session *session, 
                                Item **ref_pointer_array,
@@ -113,15 +112,8 @@
 static bool test_if_subpart(order_st *a,order_st *b);
 static void restore_prev_nj_state(JoinTable *last);
 static uint32_t make_join_orderinfo(JOIN *join);
-static int setup_semijoin_dups_elimination(JOIN *join, uint64_t options, uint32_t no_jbuf_after);
-static void cleanup_sj_tmp_tables(JOIN *join);
 static bool add_ref_to_table_cond(Session *session, JoinTable *join_tab);
-static bool replace_where_subcondition(JOIN *join, Item *old_cond, Item *new_cond, bool fix_fields);
-static int pull_out_semijoin_tables(JOIN *join);
-static int do_sj_dups_weedout(Session *session, SemiJoinTable *sjtbl);
 static void free_blobs(Field **ptr); /* Rename this method...conflicts with another in global namespace... */
-static bool bitmap_covers(const table_map x, const table_map y);
-static bool sj_table_is_included(JOIN *join, JoinTable *join_tab);
 
 /**
   Prepare of whole select (including sub queries in future).
@@ -218,63 +210,9 @@
     */
     if ((subselect= select_lex->master_unit()->item))
     {
-      bool do_semijoin= !test(session->variables.optimizer_switch &
-                              OPTIMIZER_SWITCH_NO_SEMIJOIN);
       if (subselect->substype() == Item_subselect::IN_SUBS)
         in_subs= (Item_in_subselect*)subselect;
 
-      /*
-        Check if we're in subquery that is a candidate for flattening into a
-        semi-join (which is done done in flatten_subqueries()). The
-        requirements are:
-          1. Subquery predicate is an IN/=ANY subq predicate
-          2. Subquery is a single SELECT (not a UNION)
-          3. Subquery does not have GROUP BY or order_st BY
-          4. Subquery does not use aggregate functions or HAVING
-          5. Subquery predicate is at the AND-top-level of ON/WHERE clause
-          6. No execution method was already chosen (by a prepared statement).
-
-          (*). We are not in a subquery of a single table UPDATE/DELETE that
-               doesn't have a JOIN (TODO: We should handle this at some
-               point by switching to multi-table UPDATE/DELETE)
-
-          (**). We're not in a confluent table-less subquery, like
-                "SELECT 1".
-      */
-      if (in_subs &&                                                    // 1
-          !select_lex->master_unit()->first_select()->next_select() &&  // 2
-          !select_lex->group_list.elements && !order &&                 // 3
-          !having && !select_lex->with_sum_func &&                      // 4
-          session->session_marker &&                                            // 5
-          select_lex->outer_select()->join &&                           // (*)
-          select_lex->master_unit()->first_select()->leaf_tables &&     // (**)
-          do_semijoin &&
-          in_subs->exec_method == Item_in_subselect::NOT_TRANSFORMED)   // 6
-      {
-        {
-          if (!in_subs->left_expr->fixed &&
-               in_subs->left_expr->fix_fields(session, &in_subs->left_expr))
-          {
-            return(-1);
-          }
-          /*
-            Check that the right part of the subselect contains no more than one
-            column. E.g. in SELECT 1 IN (SELECT * ..) the right part is (SELECT * ...)
-          */
-          if (subselect->substype() == Item_subselect::IN_SUBS &&
-             (select_lex->item_list.elements !=
-              ((Item_in_subselect*)subselect)->left_expr->cols()))
-          {
-            my_error(ER_OPERAND_COLUMNS, MYF(0), ((Item_in_subselect*)subselect)->left_expr->cols());
-            return(-1);
-          }
-        }
-
-        /* Register the subquery for further processing */
-        select_lex->outer_select()->join->sj_subselects.append(session->mem_root, in_subs);
-        in_subs->expr_join_nest= (TableList*)session->session_marker;
-      }
-      else
       {
         bool do_materialize= !test(session->variables.optimizer_switch &
                                    OPTIMIZER_SWITCH_NO_MATERIALIZATION);
@@ -507,7 +445,7 @@
 #endif
 
   /* Convert all outer joins to inner joins if possible */
-  conds= simplify_joins(this, join_list, conds, true, false);
+  conds= simplify_joins(this, join_list, conds, true);
   build_bitmap_for_nested_joins(join_list, 0);
 
   conds= optimize_cond(this, conds, join_list, &cond_value);
@@ -878,10 +816,6 @@
   uint64_t select_opts_for_readinfo=
     (select_options & (SELECT_DESCRIBE | SELECT_NO_JOIN_CACHE)) | (0);
 
-  sj_tmp_tables= NULL;
-  if (!select_lex->sj_nests.is_empty())
-    setup_semijoin_dups_elimination(this, select_opts_for_readinfo, no_jbuf_after);
-
   // No cache for MATCH == 'Don't use join buffering when we use MATCH'.
   if (make_join_readinfo(this, select_opts_for_readinfo, no_jbuf_after))
     return(1);
@@ -1761,113 +1695,6 @@
   return(error);
 }
 
-/*
-  Convert candidate subquery predicates to semi-joins
-
-  SYNOPSIS
-    JOIN::flatten_subqueries()
-
-  DESCRIPTION
-    Convert candidate subquery predicates to semi-joins.
-
-  RETURN
-    false  OK
-    true   Error
-*/
-bool JOIN::flatten_subqueries()
-{
-  Item_in_subselect **in_subq;
-  Item_in_subselect **in_subq_end;
-
-  if (sj_subselects.elements() == 0)
-    return(false);
-
-  /* 1. Fix children subqueries */
-  for (in_subq= sj_subselects.front(), in_subq_end= sj_subselects.back();
-       in_subq != in_subq_end; in_subq++)
-  {
-    JOIN *child_join= (*in_subq)->unit->first_select()->join;
-    child_join->outer_tables = child_join->tables;
-    if (child_join->flatten_subqueries())
-      return(true);
-    (*in_subq)->sj_convert_priority=
-      (*in_subq)->is_correlated * MAX_TABLES + child_join->outer_tables;
-  }
-  
-  bool outer_join_disable_semi_join= false;
-  /*
-   * Temporary measure: disable semi-joins when they are together with outer
-   * joins.
-   *
-   * @see LP Bug #314911
-   */
-  for (TableList *tbl= select_lex->leaf_tables; tbl; tbl=tbl->next_leaf)
-  {
-    TableList *embedding= tbl->embedding;
-    if (tbl->on_expr || (tbl->embedding && !(embedding->sj_on_expr && 
-                                            !embedding->embedding)))
-    {
-      in_subq= sj_subselects.front();
-      outer_join_disable_semi_join= true;
-    }
-  }
-
-  if (! outer_join_disable_semi_join)
-  {
-    /*
-      2. Pick which subqueries to convert:
-        sort the subquery array
-        - prefer correlated subqueries over uncorrelated;
-        - prefer subqueries that have greater number of outer tables;
-    */
-    sj_subselects.sort(subq_sj_candidate_cmp);
-    // #tables-in-parent-query + #tables-in-subquery < MAX_TABLES
-    /* Replace all subqueries to be flattened with Item_int(1) */
-    for (in_subq= sj_subselects.front();
-        in_subq != in_subq_end &&
-        tables + ((*in_subq)->sj_convert_priority % MAX_TABLES) < MAX_TABLES;
-        in_subq++)
-    {
-      if (replace_where_subcondition(this, *in_subq, new Item_int(1), false))
-        return(true);
-    }
-
-    for (in_subq= sj_subselects.front();
-        in_subq != in_subq_end &&
-        tables + ((*in_subq)->sj_convert_priority % MAX_TABLES) < MAX_TABLES;
-        in_subq++)
-    {
-      if (convert_subq_to_sj(this, *in_subq))
-        return(true);
-    }
-  }
-
-  /* 3. Finalize those we didn't convert */
-  for (; in_subq!= in_subq_end; in_subq++)
-  {
-    JOIN *child_join= (*in_subq)->unit->first_select()->join;
-    Item_subselect::trans_res res;
-    (*in_subq)->changed= 0;
-    (*in_subq)->fixed= 0;
-    res= (*in_subq)->select_transformer(child_join);
-    if (res == Item_subselect::RES_ERROR)
-      return(true);
-
-    (*in_subq)->changed= 1;
-    (*in_subq)->fixed= 1;
-
-    Item *substitute= (*in_subq)->substitution;
-    bool do_fix_fields= !(*in_subq)->substitution->fixed;
-    if (replace_where_subcondition(this, *in_subq, substitute, do_fix_fields))
-      return(true);
-
-    //if ((*in_subq)->fix_fields(session, (*in_subq)->ref_ptr))
-    //  return(true);
-  }
-  sj_subselects.clear();
-  return(false);
-}
-
 /**
   Setup for execution all subqueries of a query, for which the optimizer
   chose hash semi-join.
@@ -2049,7 +1876,6 @@
           tab->table->file->ha_index_or_rnd_end();
       }
     }
-    cleanup_sj_tmp_tables(this);//
   }
   /*
     We are not using tables anymore
@@ -2663,22 +2489,6 @@
 
     JoinTable *return_tab= join->return_tab;
     join_tab->found_match= true;
-    if (join_tab->check_weed_out_table)
-    {
-      int res= do_sj_dups_weedout(join->session, join_tab->check_weed_out_table);
-      if (res == -1)
-        return NESTED_LOOP_ERROR;
-      if (res == 1)
-        return NESTED_LOOP_OK;
-    }
-    else if (join_tab->do_firstmatch)
-    {
-      /*
-        We should return to the join_tab->do_firstmatch after we have
-        enumerated all the suffixes for current prefix row combination
-      */
-      return_tab= join_tab->do_firstmatch;
-    }
 
     /*
       It was not just a return to lower loop level when one
@@ -2838,16 +2648,14 @@
 	      if (!select || !select->skip_record())
         {
           int res= 0;
-          if (!join_tab->check_weed_out_table ||
-              !(res= do_sj_dups_weedout(join->session, join_tab->check_weed_out_table)))
+
+          rc= (join_tab->next_select)(join,join_tab+1,0);
+          if (rc != NESTED_LOOP_OK && rc != NESTED_LOOP_NO_MORE_ROWS)
           {
-            rc= (join_tab->next_select)(join,join_tab+1,0);
-            if (rc != NESTED_LOOP_OK && rc != NESTED_LOOP_NO_MORE_ROWS)
-            {
-              reset_cache_write(&join_tab->cache);
-              return rc;
-            }
+            reset_cache_write(&join_tab->cache);
+            return rc;
           }
+
           if (res == -1)
             return NESTED_LOOP_ERROR;
         }
@@ -3274,7 +3082,6 @@
         (!idx|| !check_interleaving_with_nj(join->positions[idx-1].table, s)))
     {
       double records, best;
-      advance_sj_state(rest_tables, s);
       best_access_path(join, s, session, rest_tables, idx, record_count,
                        read_time);
       records= join->positions[idx].records_read;
@@ -3303,7 +3110,6 @@
         std::swap(join->best_ref[idx], *pos);
       }
       restore_prev_nj_state(s);
-      restore_prev_sj_state(rest_tables, s);
       if (join->select_options & SELECT_STRAIGHT_JOIN)
   break;        // Don't test all combinations
     }
@@ -3525,7 +3331,6 @@
   my_qsort(join->best_ref + join->const_tables,
            join->tables - join->const_tables, sizeof(JoinTable*),
            straight_join ? join_tab_cmp_straight : join_tab_cmp);
-  join->cur_emb_sj_nests= 0;
   if (straight_join)
   {
     optimize_straight_join(join, join_tables);
@@ -3603,7 +3408,6 @@
   table_map best_ref_depends_map= 0;
   double tmp;
   ha_rows rec;
-  uint32_t best_is_sj_inside_out=    0;
 
   if (s->keyuse)
   {                                            /* Use key if possible */
@@ -3611,29 +3415,6 @@
     KeyUse *keyuse,*start_key=0;
     double best_records= DBL_MAX;
     uint32_t max_key_part=0;
-    uint64_t bound_sj_equalities= 0;
-    bool try_sj_inside_out= false;
-    /*
-      Discover the bound equalites. We need to do this, if
-        1. The next table is an SJ-inner table, and
-        2. It is the first table from that semijoin, and
-        3. We're not within a semi-join range (i.e. all semi-joins either have
-           all or none of their tables in join_table_map), except
-           s->emb_sj_nest (which we've just entered).
-        3. All correlation references from this sj-nest are bound
-    */
-    if (s->emb_sj_nest &&                                                 // (1)
-        s->emb_sj_nest->sj_in_exprs < 64 &&
-        ((remaining_tables & s->emb_sj_nest->sj_inner_tables) ==           // (2)
-         s->emb_sj_nest->sj_inner_tables) &&                               // (2)
-        join->cur_emb_sj_nests == s->emb_sj_nest->sj_inner_tables &&       // (3)
-        !(remaining_tables & s->emb_sj_nest->nested_join->sj_corr_tables)) // (4)
-    {
-      /* This table is an InsideOut scan candidate */
-      bound_sj_equalities= get_bound_sj_equalities(s->emb_sj_nest,
-                                                   remaining_tables);
-      try_sj_inside_out= true;
-    }
 
     /* Test how we can use keys */
     rec= s->records/MATCHING_ROWS_IN_OTHER_TABLE;  // Assumed records/key
@@ -3650,8 +3431,6 @@
 
       /* Calculate how many key segments of the current key we can use */
       start_key= keyuse;
-      uint64_t handled_sj_equalities=0;
-      key_part_map sj_insideout_map= 0;
 
       do /* For each keypart */
       {
@@ -3691,17 +3470,6 @@
               ref_or_null_part |= keyuse->keypart_map;
           }
 
-          if (try_sj_inside_out && keyuse->sj_pred_no != UINT_MAX)
-          {
-            if (!(remaining_tables & keyuse->used_tables))
-              bound_sj_equalities |= 1UL << keyuse->sj_pred_no;
-            else
-            {
-              handled_sj_equalities |= 1UL << keyuse->sj_pred_no;
-              sj_insideout_map |= ((key_part_map)1) << keyuse->keypart;
-            }
-          }
-
           keyuse++;
         } while (keyuse->table == table && keyuse->key == key &&
                  keyuse->keypart == keypart);
@@ -3711,60 +3479,14 @@
       /*
         Assume that that each key matches a proportional part of table.
       */
-      if (!found_part && !handled_sj_equalities)
+      if (!found_part)
         continue;                               // Nothing usable found
 
       if (rec < MATCHING_ROWS_IN_OTHER_TABLE)
         rec= MATCHING_ROWS_IN_OTHER_TABLE;      // Fix for small tables
 
-      bool sj_inside_out_scan= false;
       {
         found_constraint= 1;
-        /*
-          Check if InsideOut scan is applicable:
-          1. All IN-equalities are either "bound" or "handled"
-          2. Index keyparts are
-             ...
-        */
-        if (try_sj_inside_out &&
-            table->covering_keys.test(key) &&
-            (handled_sj_equalities | bound_sj_equalities) ==     // (1)
-            PREV_BITS(uint64_t, s->emb_sj_nest->sj_in_exprs)) // (1)
-        {
-          uint32_t n_fixed_parts= max_part_bit(found_part);
-          if (n_fixed_parts != keyinfo->key_parts &&
-              (PREV_BITS(uint, n_fixed_parts) | sj_insideout_map) ==
-               PREV_BITS(uint, keyinfo->key_parts))
-          {
-            /*
-              Not all parts are fixed. Produce bitmap of remaining bits and
-              check if all of them are covered.
-            */
-            sj_inside_out_scan= true;
-            if (!n_fixed_parts)
-            {
-              /*
-                It's a confluent ref scan.
-
-                That is, all found KeyUse elements refer to IN-equalities,
-                and there is really no ref access because there is no
-                  t.keypart0 = {bound expression}
-
-                Calculate the cost of complete loose index scan.
-              */
-              records= (double)s->table->file->stats.records;
-
-              /* The cost is entire index scan cost (divided by 2) */
-              best_time= s->table->file->index_only_read_time(key, records);
-
-              /* Now figure how many different keys we will get */
-              ulong rpc;
-              if ((rpc= keyinfo->rec_per_key[keyinfo->key_parts-1]))
-                records= records / rpc;
-              start_key= NULL;
-            }
-          }
-        }
 
         /*
           Check if we found full key
@@ -4017,13 +3739,6 @@
             tmp= best_time;                    // Do nothing
         }
 
-        if (sj_inside_out_scan && !start_key)
-        {
-          tmp= tmp/2;
-          if (records)
-            records= records/2;
-        }
-
       }
       if (tmp < best_time - records/(double) TIME_FOR_COMPARE)
       {
@@ -4033,7 +3748,6 @@
         best_key= start_key;
         best_max_key_part= max_key_part;
         best_ref_depends_map= found_ref;
-        best_is_sj_inside_out= sj_inside_out_scan;
       }
     }
     records= best_records;
@@ -4164,7 +3878,6 @@
       best_key= 0;
       /* range/index_merge/ALL/index access method are "independent", so: */
       best_ref_depends_map= 0;
-      best_is_sj_inside_out= false;
     }
   }
 
@@ -4174,7 +3887,6 @@
   join->positions[idx].key=          best_key;
   join->positions[idx].table=        s;
   join->positions[idx].ref_depend_map= best_ref_depends_map;
-  join->positions[idx].use_insideout_scan= best_is_sj_inside_out;
 
   if (!best_key &&
       idx == join->const_tables &&
@@ -4217,7 +3929,6 @@
   for (JoinTable **pos= join->best_ref + idx ; (s= *pos) ; pos++)
   {
     /* Find the best access method from 's' to the current partial plan */
-    advance_sj_state(join_tables, s);
     best_access_path(join, s, join->session, join_tables, idx,
                      record_count, read_time);
     /* compute the cost of the new plan extended with 's' */
@@ -4521,7 +4232,6 @@
         (!idx || !check_interleaving_with_nj(join->positions[idx-1].table, s)))
     {
       double current_record_count, current_read_time;
-      advance_sj_state(remaining_tables, s);
 
       /*
         psergey-insideout-todo:
@@ -4542,7 +4252,6 @@
            current_record_count / (double) TIME_FOR_COMPARE) >= join->best_read)
       {
         restore_prev_nj_state(s);
-        restore_prev_sj_state(remaining_tables, s);
         continue;
       }
 
@@ -4569,7 +4278,6 @@
         else
         {
           restore_prev_nj_state(s);
-          restore_prev_sj_state(remaining_tables, s);
           continue;
         }
       }
@@ -4606,7 +4314,6 @@
         }
       }
       restore_prev_nj_state(s);
-      restore_prev_sj_state(remaining_tables, s);
     }
   }
   return(false);
@@ -4719,8 +4426,6 @@
   join_tab->read_first_record= join_init_read_record;
   join_tab->join=join;
   join_tab->ref.key_parts= 0;
-  join_tab->flush_weedout_table= join_tab->check_weed_out_table= NULL;
-  join_tab->do_firstmatch= NULL;
   memset(&join_tab->read_record, 0, sizeof(join_tab->read_record));
   tmp_table->status=0;
   tmp_table->null_row=0;
@@ -5679,7 +5384,7 @@
     - The new condition, if success
     - 0, otherwise
 */
-static COND *simplify_joins(JOIN *join, List<TableList> *join_list, COND *conds, bool top, bool in_sj)
+static COND *simplify_joins(JOIN *join, List<TableList> *join_list, COND *conds, bool top)
 {
   TableList *table;
   nested_join_st *nested_join;
@@ -5712,8 +5417,7 @@
            the outer join is converted to an inner join and
            the corresponding on expression is added to E.
 	      */
-        expr= simplify_joins(join, &nested_join->join_list,
-                             expr, false, in_sj || table->sj_on_expr);
+        expr= simplify_joins(join, &nested_join->join_list, expr, false);
 
         if (!table->prep_on_expr || expr != table->on_expr)
         {
@@ -5725,7 +5429,7 @@
       }
       nested_join->used_tables= (table_map) 0;
       nested_join->not_null_tables=(table_map) 0;
-      conds= simplify_joins(join, &nested_join->join_list, conds, top, in_sj || table->sj_on_expr);
+      conds= simplify_joins(join, &nested_join->join_list, conds, top);
       used_tables= nested_join->used_tables;
       not_null_tables= nested_join->not_null_tables;
     }
@@ -5823,15 +5527,7 @@
   while ((table= li++))
   {
     nested_join= table->nested_join;
-    if (table->sj_on_expr && !in_sj)
-    {
-       /*
-         If this is a semi-join that is not contained within another semi-join,
-         leave it intact (otherwise it is flattened)
-       */
-      join->select_lex->sj_nests.push_back(table);
-    }
-    else if (nested_join && !table->on_expr)
+    if (nested_join && !table->on_expr)
     {
       TableList *tbl;
       List_iterator<TableList> it(nested_join->join_list);
@@ -6007,7 +5703,7 @@
         s->embedding_map|= embedding->nested_join->nj_map;
       continue;
     }
-    if (embedding && !(embedding->sj_on_expr && ! embedding->embedding))
+    if (embedding && !(false && ! embedding->embedding))
     {
       /* s belongs to a nested join, maybe to several embedded joins */
       s->embedding_map= 0;
@@ -6245,9 +5941,6 @@
     }
   }
 
-  if (pull_out_semijoin_tables(join))
-    return(true);
-
   /* Calc how many (possible) matched records in each table */
 
   for (s=stat ; s < stat_end ; s++)
@@ -6526,355 +6219,6 @@
 }
 
 /**
-  Setup the strategies to eliminate semi-join duplicates.
-
-  SYNOPSIS
-    setup_semijoin_dups_elimination()
-      join           Join to process
-      options        Join options (needed to see if join buffering will be
-                     used or not)
-      no_jbuf_after  Another bit of information re where join buffering will
-                     be used.
-
-  DESCRIPTION
-    Setup the strategies to eliminate semi-join duplicates. ATM there are 3
-    strategies:
-
-    1. DuplicateWeedout (use of temptable to remove duplicates based on rowids
-                         of row combinations)
-    2. FirstMatch (pick only the 1st matching row combination of inner tables)
-    3. InsideOut (scanning the sj-inner table in a way that groups duplicates
-                  together and picking the 1st one)
-
-    The join order has "duplicate-generating ranges", and every range is
-    served by one strategy or a combination of FirstMatch with with some
-    other strategy.
-
-    "Duplicate-generating range" is defined as a range within the join order
-    that contains all of the inner tables of a semi-join. All ranges must be
-    disjoint, if tables of several semi-joins are interleaved, then the ranges
-    are joined together, which is equivalent to converting
-      SELECT ... WHERE oe1 IN (SELECT ie1 ...) AND oe2 IN (SELECT ie2 )
-    to
-      SELECT ... WHERE (oe1, oe2) IN (SELECT ie1, ie2 ... ...)
-    .
-
-    Applicability conditions are as follows:
-
-    DuplicateWeedout strategy
-    ~~~~~~~~~~~~~~~~~~~~~~~~~
-
-      (ot|nt)*  [ it ((it|ot|nt)* (it|ot))]  (nt)*
-      +------+  +=========================+  +---+
-        (1)                 (2)               (3)
-
-       (1) - Prefix of OuterTables (those that participate in
-             IN-equality and/or are correlated with subquery) and outer
-             Noncorrelated Tables.
-       (2) - The handled range. The range starts with the first sj-inner
-             table, and covers all sj-inner and outer tables
-             Within the range,  Inner, Outer, outer Noncorrelated tables
-             may follow in any order.
-       (3) - The suffix of outer Noncorrelated tables.
-
-    FirstMatch strategy
-    ~~~~~~~~~~~~~~~~~~~
-
-      (ot|nt)*  [ it ((it|nt)* it) ]  (nt)*
-      +------+  +==================+  +---+
-        (1)             (2)          (3)
-
-      (1) - Prefix of outer and non-correlated tables
-      (2) - The handled range, which may contain only inner and
-            non-correlated tables.
-      (3) - The suffix of outer Noncorrelated tables.
-
-    InsideOut strategy
-    ~~~~~~~~~~~~~~~~~~
-
-     (ot|ct|nt) [ insideout_tbl (ot|nt|it)* it ]  (ot|nt)*
-     +--------+   +===========+ +=============+   +------+
-        (1)           (2)          (3)              (4)
-
-      (1) - Prefix that may contain any outer tables. The prefix must contain
-            all the non-trivially correlated outer tables. (non-trivially means
-            that the correlation is not just through the IN-equality).
-
-      (2) - Inner table for which the InsideOut scan is performed.
-
-      (3) - The remainder of the duplicate-generating range. It is served by
-            application of FirstMatch strategy, with the exception that
-            outer IN-correlated tables are considered to be non-correlated.
-
-      (4) - THe suffix of outer and outer non-correlated tables.
-
-    If several strategies are applicable, their relative priorities are:
-      1. InsideOut
-      2. FirstMatch
-      3. DuplicateWeedout
-
-    This function walks over the join order and sets up the strategies by
-    setting appropriate members in join_tab structures.
-
-  RETURN
-    false  OK
-    true   Out of memory error
-*/
-static int setup_semijoin_dups_elimination(JOIN *join, uint64_t options, uint32_t no_jbuf_after)
-{
-  table_map cur_map= join->const_table_map | PSEUDO_TABLE_BITS;
-  struct {
-    /*
-      0 - invalid (EOF marker),
-      1 - InsideOut,
-      2 - Temptable (maybe confluent),
-      3 - Temptable with join buffering
-    */
-    uint32_t strategy;
-    uint32_t start_idx; /* Left range bound */
-    uint32_t end_idx;   /* Right range bound */
-    /*
-      For Temptable strategy: Bitmap of all outer and correlated tables from
-      all involved join nests.
-    */
-    table_map outer_tables;
-  } dups_ranges [MAX_TABLES];
-
-  TableList *emb_insideout_nest= NULL;
-  table_map emb_sj_map= 0;  /* A bitmap of sj-nests (that is, their sj-inner
-                               tables) whose ranges we're in */
-  table_map emb_outer_tables= 0; /* sj-outer tables for those sj-nests */
-  table_map range_start_map= 0; /* table_map at current range start */
-  bool dealing_with_jbuf= false; /* true <=> table within cur range uses join buf */
-  int cur_range= 0;
-  uint32_t i;
-
-  /*
-    First pass: locate the duplicate-generating ranges and pick the strategies.
-  */
-  for (i=join->const_tables ; i < join->tables ; i++)
-  {
-    JoinTable *tab=join->join_tab+i;
-    Table *table=tab->table;
-    cur_map |= table->map;
-
-    if (tab->emb_sj_nest) // Encountered an sj-inner table
-    {
-      if (!emb_sj_map)
-      {
-        dups_ranges[cur_range].start_idx= i;
-        range_start_map= cur_map & ~table->map;
-        /*
-          Remember if this is a possible start of range that is covered by
-          the InsideOut strategy (the reason that it is not covered could
-          be that it overlaps with anther semi-join's range. we don't
-          support InsideOut for joined ranges)
-        */
-        if (join->best_positions[i].use_insideout_scan)
-          emb_insideout_nest= tab->emb_sj_nest;
-      }
-
-      emb_sj_map |= tab->emb_sj_nest->sj_inner_tables;
-      emb_outer_tables |= tab->emb_sj_nest->nested_join->sj_depends_on;
-
-      if (tab->emb_sj_nest != emb_insideout_nest)
-      {
-        /*
-          Two different semi-joins interleave. This cannot be handled by
-          InsideOut strategy.
-        */
-        emb_insideout_nest= NULL;
-      }
-    }
-
-    if (emb_sj_map) /* We're in duplicate-generating range */
-    {
-      if (i != join->const_tables && !(options & SELECT_NO_JOIN_CACHE) &&
-          tab->type == JT_ALL && tab->use_quick != 2 && !tab->first_inner &&
-          i <= no_jbuf_after && !dealing_with_jbuf)
-      {
-        /*
-          This table uses join buffering, which makes use of FirstMatch or
-          InsideOut strategies impossible for the current and (we assume)
-          preceding duplicate-producing ranges.
-          That is, for the join order:
-
-              x x [ x  x]  x  [x x x]  x  [x x X*  x] x
-                  |     |     |     |          | \
-                  +-----+     +-----+          |  join buffering use
-                     r1          r2         we're here
-
-          we'll have to remove r1 and r2 and use duplicate-elimination
-          strategy that spans all the tables, starting from the very 1st
-          one.
-        */
-        dealing_with_jbuf= true;
-        emb_insideout_nest= false;
-
-        /*
-          Absorb all preceding duplicate-eliminating ranges. Their strategies
-          do not matter:
-        */
-        for (int prev_range= 0; prev_range < cur_range; prev_range++)
-        {
-          dups_ranges[cur_range].outer_tables |=
-            dups_ranges[prev_range].outer_tables;
-        }
-        dups_ranges[0].start_idx= 0; /* Will need to start from the 1st table */
-        dups_ranges[0].outer_tables= dups_ranges[cur_range].outer_tables;
-        cur_range=  0;
-      }
-
-      /*
-        Check if we are at the end of duplicate-producing range. We are if
-
-        1. It's an InsideOut range (which presumes all correlated tables are
-           in the prefix), and all inner tables are in the join order prefix,
-           or
-        2. It's a DuplicateElimination range (possibly covering several
-           SJ-nests), and all inner, outer, and correlated tables of all
-           sj-nests are in the join order prefix.
-      */
-      bool end_of_range= false;
-      if (emb_insideout_nest &&
-          bitmap_covers(cur_map, emb_insideout_nest->sj_inner_tables))
-      {
-        /* Save that this range is handled with InsideOut: */
-        dups_ranges[cur_range].strategy= 1;
-        end_of_range= true;
-      }
-      else if (bitmap_covers(cur_map, emb_outer_tables | emb_sj_map))
-      {
-        /*
-          This is a complete range to be handled with either DuplicateWeedout
-          or FirstMatch
-        */
-        dups_ranges[cur_range].strategy= dealing_with_jbuf? 3 : 2;
-        /*
-          This will hold tables from within the range that need to be put
-          into the join buffer before we can use the FirstMatch on its tail.
-        */
-        dups_ranges[cur_range].outer_tables= emb_outer_tables &
-                                             ~range_start_map;
-        end_of_range= true;
-      }
-
-      if (end_of_range)
-      {
-        dups_ranges[cur_range].end_idx= i+1;
-        emb_sj_map= emb_outer_tables= 0;
-        emb_insideout_nest= NULL;
-        dealing_with_jbuf= false;
-        dups_ranges[++cur_range].strategy= 0;
-      }
-    }
-  }
-
-  Session *session= join->session;
-  SemiJoinTable **next_sjtbl_ptr= &join->sj_tmp_tables;
-  /*
-    Second pass: setup the chosen strategies
-  */
-  for (int j= 0; j < cur_range; j++)
-  {
-    JoinTable *tab=join->join_tab + dups_ranges[j].start_idx;
-    JoinTable *jump_to;
-    if (dups_ranges[j].strategy == 1)  // InsideOut strategy
-    {
-      tab->insideout_match_tab= join->join_tab + dups_ranges[j].end_idx - 1;
-      jump_to= tab++;
-    }
-    else // DuplicateWeedout strategy
-    {
-      SemiJoinTable::TAB sjtabs[MAX_TABLES];
-      table_map weed_cur_map= join->const_table_map | PSEUDO_TABLE_BITS;
-      uint32_t jt_rowid_offset= 0; // # tuple bytes are already occupied (w/o NULL bytes)
-      uint32_t jt_null_bits= 0;    // # null bits in tuple bytes
-      SemiJoinTable::TAB *last_tab= sjtabs;
-      uint32_t rowid_keep_flags= JoinTable::CALL_POSITION | JoinTable::KEEP_ROWID;
-      JoinTable *last_outer_tab= tab - 1;
-      /*
-        Walk through the range and remember
-         - tables that need their rowids to be put into temptable
-         - the last outer table
-      */
-      for (; tab < join->join_tab + dups_ranges[j].end_idx; tab++)
-      {
-        if (sj_table_is_included(join, tab))
-        {
-          last_tab->join_tab= tab;
-          last_tab->rowid_offset= jt_rowid_offset;
-          jt_rowid_offset += tab->table->file->ref_length;
-          if (tab->table->maybe_null)
-          {
-            last_tab->null_byte= jt_null_bits / 8;
-            last_tab->null_bit= jt_null_bits++;
-          }
-          last_tab++;
-          tab->table->prepare_for_position();
-          tab->rowid_keep_flags= rowid_keep_flags;
-        }
-        weed_cur_map |= tab->table->map;
-        if (!tab->emb_sj_nest && bitmap_covers(weed_cur_map,
-                                               dups_ranges[j].outer_tables))
-          last_outer_tab= tab;
-      }
-
-      if (jt_rowid_offset) /* Temptable has at least one rowid */
-      {
-        SemiJoinTable *sjtbl;
-        uint32_t tabs_size= (last_tab - sjtabs) * sizeof(SemiJoinTable::TAB);
-        if (!(sjtbl= (SemiJoinTable*)session->alloc(sizeof(SemiJoinTable))) ||
-            !(sjtbl->tabs= (SemiJoinTable::TAB*) session->alloc(tabs_size)))
-          return(true);
-        memcpy(sjtbl->tabs, sjtabs, tabs_size);
-        sjtbl->tabs_end= sjtbl->tabs + (last_tab - sjtabs);
-        sjtbl->rowid_len= jt_rowid_offset;
-        sjtbl->null_bits= jt_null_bits;
-        sjtbl->null_bytes= (jt_null_bits + 7)/8;
-
-        *next_sjtbl_ptr= sjtbl;
-        next_sjtbl_ptr= &(sjtbl->next);
-        sjtbl->next= NULL;
-
-        sjtbl->tmp_table=
-          sjtbl->createTable(session,
-                             sjtbl->rowid_len +
-                             sjtbl->null_bytes);
-
-        join->join_tab[dups_ranges[j].start_idx].flush_weedout_table= sjtbl;
-        join->join_tab[dups_ranges[j].end_idx - 1].check_weed_out_table= sjtbl;
-      }
-      tab= last_outer_tab + 1;
-      jump_to= last_outer_tab;
-    }
-
-    /* Create the FirstMatch tail */
-    for (; tab < join->join_tab + dups_ranges[j].end_idx; tab++)
-    {
-      if (tab->emb_sj_nest)
-        tab->do_firstmatch= jump_to;
-      else
-        jump_to= tab;
-    }
-  }
-  return(false);
-}
-
-static void cleanup_sj_tmp_tables(JOIN *join)
-{
-  for (SemiJoinTable *sj_tbl= join->sj_tmp_tables; sj_tbl;
-       sj_tbl= sj_tbl->next)
-  {
-    if (sj_tbl->tmp_table)
-    {
-      sj_tbl->tmp_table->free_tmp_table(join->session);
-    }
-  }
-  join->sj_tmp_tables= NULL;
-}
-
-/**
   Create a condition for a const reference and add this to the
   currenct select for the table.
 */
@@ -6913,236 +6257,6 @@
   return(error ? true : false);
 }
 
-/**
-   @brief Replaces an expression destructively inside the expression tree of
-   the WHERE clase.
-
-   @note Because of current requirements for semijoin flattening, we do not
-   need to recurse here, hence this function will only examine the top-level
-   AND conditions. (see JOIN::prepare, comment above the line
-   'if (do_materialize)'
-
-   @param join The top-level query.
-   @param old_cond The expression to be replaced.
-   @param new_cond The expression to be substituted.
-   @param do_fix_fields If true, Item::fix_fields(Session*, Item**) is called for
-   the new expression.
-   @return <code>true</code> if there was an error, <code>false</code> if
-   successful.
-*/
-static bool replace_where_subcondition(JOIN *join, Item *old_cond,
-                                       Item *new_cond, bool do_fix_fields)
-{
-  if (join->conds == old_cond) {
-    join->conds= new_cond;
-    if (do_fix_fields)
-      new_cond->fix_fields(join->session, &join->conds);
-    return false;
-  }
-
-  if (join->conds->type() == Item::COND_ITEM) {
-    List_iterator<Item> li(*((Item_cond*)join->conds)->argument_list());
-    Item *item;
-    while ((item= li++))
-      if (item == old_cond)
-      {
-        li.replace(new_cond);
-        if (do_fix_fields)
-          new_cond->fix_fields(join->session, li.ref());
-        return false;
-      }
-  }
-
-  return true;
-}
-
-/*
-  Pull tables out of semi-join nests, if possible
-
-  SYNOPSIS
-    pull_out_semijoin_tables()
-      join  The join where to do the semi-join flattening
-
-  DESCRIPTION
-    Try to pull tables out of semi-join nests.
-
-    PRECONDITIONS
-    When this function is called, the join may have several semi-join nests
-    (possibly within different semi-join nests), but it is guaranteed that
-    one semi-join nest does not contain another.
-
-    ACTION
-    A table can be pulled out of the semi-join nest if
-     - It is a constant table
-     - It is accessed
-
-    POSTCONDITIONS
-     * Pulled out tables have JoinTable::emb_sj_nest == NULL (like the outer
-       tables)
-     * Tables that were not pulled out have JoinTable::emb_sj_nest.
-     * Semi-join nests TableList::sj_inner_tables
-
-    This operation is (and should be) performed at each PS execution since
-    tables may become/cease to be constant across PS reexecutions.
-
-  RETURN
-    0 - OK
-    1 - Out of memory error
-*/
-static int pull_out_semijoin_tables(JOIN *join)
-{
-  TableList *sj_nest;
-  List_iterator<TableList> sj_list_it(join->select_lex->sj_nests);
-
-  /* Try pulling out of the each of the semi-joins */
-  while ((sj_nest= sj_list_it++))
-  {
-    /* Action #1: Mark the constant tables to be pulled out */
-    table_map pulled_tables= 0;
-
-    List_iterator<TableList> child_li(sj_nest->nested_join->join_list);
-    TableList *tbl;
-    while ((tbl= child_li++))
-    {
-      if (tbl->table)
-      {
-        tbl->table->reginfo.join_tab->emb_sj_nest= sj_nest;
-        if (tbl->table->map & join->const_table_map)
-        {
-          pulled_tables |= tbl->table->map;
-        }
-      }
-    }
-
-    /*
-      Action #2: Find which tables we can pull out based on
-      update_ref_and_keys() data. Note that pulling one table out can allow
-      us to pull out some other tables too.
-    */
-    bool pulled_a_table;
-    do
-    {
-      pulled_a_table= false;
-      child_li.rewind();
-      while ((tbl= child_li++))
-      {
-        if (tbl->table && !(pulled_tables & tbl->table->map))
-        {
-          if (find_eq_ref_candidate(tbl->table,
-                                    sj_nest->nested_join->used_tables &
-                                    ~pulled_tables))
-          {
-            pulled_a_table= true;
-            pulled_tables |= tbl->table->map;
-          }
-        }
-      }
-    } while (pulled_a_table);
-
-    child_li.rewind();
-    if ((sj_nest)->nested_join->used_tables == pulled_tables)
-    {
-      (sj_nest)->sj_inner_tables= 0;
-      while ((tbl= child_li++))
-      {
-        if (tbl->table)
-          tbl->table->reginfo.join_tab->emb_sj_nest= NULL;
-      }
-    }
-    else
-    {
-      /* Record the bitmap of inner tables, mark the inner tables */
-      table_map inner_tables=(sj_nest)->nested_join->used_tables &
-                             ~pulled_tables;
-      (sj_nest)->sj_inner_tables= inner_tables;
-      while ((tbl= child_li++))
-      {
-        if (tbl->table)
-        {
-          if (inner_tables & tbl->table->map)
-            tbl->table->reginfo.join_tab->emb_sj_nest= (sj_nest);
-          else
-            tbl->table->reginfo.join_tab->emb_sj_nest= NULL;
-        }
-      }
-    }
-  }
-  return(0);
-}
-
-/*
-  SemiJoinDuplicateElimination: Weed out duplicate row combinations
-
-  SYNPOSIS
-    do_sj_dups_weedout()
-
-  RETURN
-    -1  Error
-    1   The row combination is a duplicate (discard it)
-    0   The row combination is not a duplicate (continue)
-*/
-static int do_sj_dups_weedout(Session *session, SemiJoinTable *sjtbl)
-{
-  int error;
-  SemiJoinTable::TAB *tab= sjtbl->tabs;
-  SemiJoinTable::TAB *tab_end= sjtbl->tabs_end;
-  unsigned char *ptr= sjtbl->tmp_table->record[0] + 1;
-  unsigned char *nulls_ptr= ptr;
-
-  /* Put the the rowids tuple into table->record[0]: */
-
-  // 1. Store the length
-  if (((Field_varstring*)(sjtbl->tmp_table->field[0]))->length_bytes == 1)
-  {
-    *ptr= (unsigned char)(sjtbl->rowid_len + sjtbl->null_bytes);
-    ptr++;
-  }
-  else
-  {
-    int2store(ptr, sjtbl->rowid_len + sjtbl->null_bytes);
-    ptr += 2;
-  }
-
-  // 2. Zero the null bytes
-  if (sjtbl->null_bytes)
-  {
-    memset(ptr, 0, sjtbl->null_bytes);
-    ptr += sjtbl->null_bytes;
-  }
-
-  // 3. Put the rowids
-  for (uint32_t i=0; tab != tab_end; tab++, i++)
-  {
-    handler *h= tab->join_tab->table->file;
-    if (tab->join_tab->table->maybe_null && tab->join_tab->table->null_row)
-    {
-      /* It's a NULL-complemented row */
-      *(nulls_ptr + tab->null_byte) |= tab->null_bit;
-      memset(ptr + tab->rowid_offset, 0, h->ref_length);
-    }
-    else
-    {
-      /* Copy the rowid value */
-      if (tab->join_tab->rowid_keep_flags & JoinTable::CALL_POSITION)
-        h->position(tab->join_tab->table->record[0]);
-      memcpy(ptr + tab->rowid_offset, h->ref, h->ref_length);
-    }
-  }
-
-  error= sjtbl->tmp_table->file->ha_write_row(sjtbl->tmp_table->record[0]);
-  if (error)
-  {
-    /* create_myisam_from_heap will generate error if needed */
-    if (sjtbl->tmp_table->file->is_fatal_error(error, HA_CHECK_DUP) &&
-        create_myisam_from_heap(session, sjtbl->tmp_table, sjtbl->start_recinfo,
-                                &sjtbl->recinfo, error, 1))
-      return -1;
-    //return (error == HA_ERR_FOUND_DUPP_KEY || error== HA_ERR_FOUND_DUPP_UNIQUE) ? 1: -1;
-    return 1;
-  }
-  return 0;
-}
-
 static void free_blobs(Field **ptr)
 {
   for (; *ptr ; ptr++)
@@ -7152,61 +6266,6 @@
   }
 }
 
-static bool bitmap_covers(const table_map x, const table_map y)
-{
-  return !test(y & ~x);
-}
-
-/*
-  Check if the table's rowid is included in the temptable
-
-  SYNOPSIS
-    sj_table_is_included()
-      join      The join
-      join_tab  The table to be checked
-
-  DESCRIPTION
-    SemiJoinDuplicateElimination: check the table's rowid should be included
-    in the temptable. This is so if
-
-    1. The table is not embedded within some semi-join nest
-    2. The has been pulled out of a semi-join nest, or
-
-    3. The table is functionally dependent on some previous table
-
-    [4. This is also true for constant tables that can't be
-        NULL-complemented but this function is not called for such tables]
-
-  RETURN
-    true  - Include table's rowid
-    false - Don't
-*/
-static bool sj_table_is_included(JOIN *join, JoinTable *join_tab)
-{
-  if (join_tab->emb_sj_nest)
-    return false;
-
-  /* Check if this table is functionally dependent on the tables that
-     are within the same outer join nest
-  */
-  TableList *embedding= join_tab->table->pos_in_table_list->embedding;
-  if (join_tab->type == JT_EQ_REF)
-  {
-    Table_map_iterator it(join_tab->ref.depend_map & ~PSEUDO_TABLE_BITS);
-    uint32_t idx;
-    while ((idx= it.next_bit())!=Table_map_iterator::BITMAP_END)
-    {
-      JoinTable *ref_tab= join->join_tab + idx;
-      if (embedding == ref_tab->table->pos_in_table_list->embedding)
-        return true;
-    }
-    /* Ok, functionally dependent */
-    return false;
-  }
-  /* Not functionally dependent => need to include*/
-  return true;
-}
-
 /**
   @} (end of group Query_Optimizer)
 */

=== modified file 'drizzled/join.h'
--- drizzled/join.h	2009-07-09 22:21:12 +0000
+++ drizzled/join.h	2009-07-28 17:52:18 +0000
@@ -192,11 +192,6 @@
   uint32_t ref_pointer_array_size; ///< size of above in bytes
   const char *zero_result_cause; ///< not 0 if exec must return zero result
 
-  /* Descriptions of temporary tables used to weed-out semi-join duplicates */
-  SemiJoinTable  *sj_tmp_tables;
-
-  table_map cur_emb_sj_nests;
-
   /*
     storage for caching buffers allocated during query execution.
     These buffers allocations need to be cached as the thread memory pool is
@@ -282,7 +277,6 @@
       items3(NULL),
       ref_pointer_array_size(0),
       zero_result_cause(NULL),
-      sj_tmp_tables(NULL),
       sortorder(NULL),
       table_reexec(NULL),
       join_tab_reexec(NULL)
@@ -373,7 +367,6 @@
     items3= NULL;
     ref_pointer_array_size= 0;
     zero_result_cause= NULL;
-    sj_tmp_tables= NULL;
     sortorder= NULL;
     table_reexec= NULL;
     join_tab_reexec= NULL;
@@ -402,7 +395,6 @@
   int destroy();
   void restore_tmp();
   bool alloc_func_list();
-  bool flatten_subqueries();
   bool setup_subquery_materialization();
   bool make_sum_func_list(List<Item> &all_fields, 
                           List<Item> &send_fields,

=== modified file 'drizzled/join_table.h'
--- drizzled/join_table.h	2009-07-11 19:15:43 +0000
+++ drizzled/join_table.h	2009-07-28 17:52:18 +0000
@@ -39,7 +39,6 @@
 #define TAB_INFO_USING_WHERE 4
 #define TAB_INFO_FULL_SCAN_ON_NULL 8
 
-class SemiJoinTable;
 class KeyUse;
 class Table;
 class SQL_SELECT;
@@ -153,17 +152,6 @@
   JOIN *join;
 
   /**
-    Embedding SJ-nest (may be not the direct parent), or NULL if none.
-    This variable holds the result of table pullout.
-  */
-  TableList *emb_sj_nest;
-
-  /** Variables for semi-join duplicate elimination */
-  SemiJoinTable *flush_weedout_table;
-  SemiJoinTable *check_weed_out_table;
-  JoinTable *do_firstmatch;
-
-  /**
      ptr  - this join tab should do an InsideOut scan. Points
             to the tab for which we'll need to check tab->found_match.
 

=== modified file 'drizzled/plugin/storage_engine.h'
--- drizzled/plugin/storage_engine.h	2009-07-27 02:51:32 +0000
+++ drizzled/plugin/storage_engine.h	2009-07-29 06:42:06 +0000
@@ -45,7 +45,6 @@
 
 /* Possible flags of a StorageEngine (there can be 32 of them) */
 enum engine_flag_bits {
-  HTON_BIT_CLOSE_CURSORS_AT_COMMIT,
   HTON_BIT_ALTER_NOT_SUPPORTED,       // Engine does not support alter
   HTON_BIT_CAN_RECREATE,              // Delete all is used for truncate
   HTON_BIT_HIDDEN,                    // Engine does not appear in lists
@@ -59,7 +58,6 @@
 };
 
 static const std::bitset<HTON_BIT_SIZE> HTON_NO_FLAGS(0);
-static const std::bitset<HTON_BIT_SIZE> HTON_CLOSE_CURSORS_AT_COMMIT(1 <<  HTON_BIT_CLOSE_CURSORS_AT_COMMIT);
 static const std::bitset<HTON_BIT_SIZE> HTON_ALTER_NOT_SUPPORTED(1 << HTON_BIT_ALTER_NOT_SUPPORTED);
 static const std::bitset<HTON_BIT_SIZE> HTON_CAN_RECREATE(1 << HTON_BIT_CAN_RECREATE);
 static const std::bitset<HTON_BIT_SIZE> HTON_HIDDEN(1 << HTON_BIT_HIDDEN);

=== removed file 'drizzled/semi_join_table.cc'
--- drizzled/semi_join_table.cc	2009-07-11 07:38:37 +0000
+++ drizzled/semi_join_table.cc	1970-01-01 00:00:00 +0000
@@ -1,331 +0,0 @@
-/* - mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems, Inc.
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#include <drizzled/global.h>
-#include <drizzled/semi_join_table.h>
-#include <drizzled/session.h>
-#include <drizzled/field/varstring.h>
-
-#include <algorithm>
-
-using namespace std;
-
-/*
-  Create a temporary table to weed out duplicate rowid combinations
-
-  SYNOPSIS
-
-  create_duplicate_weedout_tmp_table()
-  session
-  uniq_tuple_length_arg
-  SemiJoinTable
-
-  DESCRIPTION
-  Create a temporary table to weed out duplicate rowid combinations. The
-  table has a single column that is a concatenation of all rowids in the
-  combination.
-
-  Depending on the needed length, there are two cases:
-
-  1. When the length of the column < max_key_length:
-
-  CREATE TABLE tmp (col VARBINARY(n) NOT NULL, UNIQUE KEY(col));
-
-  2. Otherwise (not a valid SQL syntax but internally supported):
-
-  CREATE TABLE tmp (col VARBINARY NOT NULL, UNIQUE CONSTRAINT(col));
-
-  The code in this function was produced by extraction of relevant parts
-  from create_tmp_table().
-
-  RETURN
-  created table
-  NULL on error
-*/
-
-Table *SemiJoinTable::createTable(Session *session,
-                                  uint32_t uniq_tuple_length_arg)
-{
-  MEM_ROOT *mem_root_save, own_root;
-  Table *table;
-  TableShare *share;
-  char  *tmpname,path[FN_REFLEN];
-  Field **reg_field;
-  KEY_PART_INFO *key_part_info;
-  KEY *keyinfo;
-  unsigned char *group_buff;
-  unsigned char *bitmaps;
-  uint32_t *blob_field;
-  MI_COLUMNDEF *record_info, *start_record_info;
-  bool using_unique_constraint=false;
-  Field *field, *key_field;
-  uint32_t blob_count, null_pack_length, null_count;
-  unsigned char *null_flags;
-  unsigned char *pos;
-
-  /*
-    STEP 1: Get temporary table name
-  */
-  statistic_increment(session->status_var.created_tmp_tables, &LOCK_status);
-
-  /* if we run out of slots or we are not using tempool */
-  sprintf(path,"%s%lx_%"PRIx64"_%x", TMP_FILE_PREFIX, (unsigned long)current_pid,
-          session->thread_id, session->tmp_table++);
-  fn_format(path, path, drizzle_tmpdir, "", MY_REPLACE_EXT|MY_UNPACK_FILENAME);
-
-  /* STEP 2: Figure if we'll be using a key or blob+constraint */
-  if (uniq_tuple_length_arg >= CONVERT_IF_BIGGER_TO_BLOB)
-    using_unique_constraint= true;
-
-  /* STEP 3: Allocate memory for temptable description */
-  init_sql_alloc(&own_root, TABLE_ALLOC_BLOCK_SIZE, 0);
-  if (!multi_alloc_root(&own_root,
-                        &table, sizeof(*table),
-                        &share, sizeof(*share),
-                        &reg_field, sizeof(Field*) * (1+1),
-                        &blob_field, sizeof(uint32_t)*2,
-                        &keyinfo, sizeof(*keyinfo),
-                        &key_part_info, sizeof(*key_part_info) * 2,
-                        &start_record_info,
-                        sizeof(*record_info)*(1*2+4),
-                        &tmpname, (uint32_t) strlen(path)+1,
-                        &group_buff, (!using_unique_constraint ?
-                                      uniq_tuple_length_arg : 0),
-                        &bitmaps, bitmap_buffer_size(1)*2,
-                        NULL))
-  {
-    return NULL;
-  }
-  strcpy(tmpname,path);
-
-  /* STEP 4: Create Table description */
-  memset(table, 0, sizeof(*table));
-  memset(reg_field, 0, sizeof(Field*)*2);
-
-  table->mem_root= own_root;
-  mem_root_save= session->mem_root;
-  session->mem_root= &table->mem_root;
-
-  table->field=reg_field;
-  table->alias= "weedout-tmp";
-  table->reginfo.lock_type=TL_WRITE;  /* Will be updated */
-  table->db_stat=HA_OPEN_KEYFILE+HA_OPEN_RNDFILE;
-  table->map=1;
-  table->copy_blobs= 1;
-  table->in_use= session;
-  table->quick_keys.reset();
-  table->covering_keys.reset();
-  table->keys_in_use_for_query.reset();
-
-  table->s= share;
-  share->init(tmpname, tmpname);
-  share->blob_field= blob_field;
-  share->blob_ptr_size= portable_sizeof_char_ptr;
-  share->db_low_byte_first=1;                // True for HEAP and MyISAM
-  share->table_charset= NULL;
-  share->primary_key= MAX_KEY;               // Indicate no primary key
-  share->keys_for_keyread.reset();
-  share->keys_in_use.reset();
-
-  blob_count= 0;
-
-  /* Create the field */
-  {
-    /*
-      For the sake of uniformity, always use Field_varstring.
-    */
-    field= new Field_varstring(uniq_tuple_length_arg, false, "rowids", share,
-                               &my_charset_bin);
-    if (!field)
-      return NULL;
-    field->table= table;
-    field->key_start.reset();
-    field->part_of_key.reset();
-    field->part_of_sortkey.reset();
-    field->unireg_check= Field::NONE;
-    field->flags= (NOT_NULL_FLAG | BINARY_FLAG | NO_DEFAULT_VALUE_FLAG);
-    field->reset_fields();
-    field->init(table);
-    field->orig_table= NULL;
-
-    field->field_index= 0;
-
-    *(reg_field++)= field;
-    *blob_field= 0;
-    *reg_field= 0;
-
-    share->fields= 1;
-    share->blob_fields= 0;
-  }
-
-  uint32_t reclength= field->pack_length();
-  if (using_unique_constraint)
-  {
-    share->storage_engine= myisam_engine;
-    table->file= get_new_handler(share, &table->mem_root,
-                                 share->db_type());
-    assert(uniq_tuple_length_arg <= table->file->max_key_length());
-  }
-  else
-  {
-    share->storage_engine= heap_engine;
-    table->file= get_new_handler(share, &table->mem_root,
-                                 share->db_type());
-  }
-  if (!table->file)
-    goto err;
-
-  null_count=1;
-
-  null_pack_length= 1;
-  reclength += null_pack_length;
-
-  share->reclength= reclength;
-  {
-    uint32_t alloc_length=ALIGN_SIZE(share->reclength + MI_UNIQUE_HASH_LENGTH+1);
-    share->rec_buff_length= alloc_length;
-    if (!(table->record[0]= (unsigned char*)
-          alloc_root(&table->mem_root, alloc_length*3)))
-      goto err;
-    table->record[1]= table->record[0]+alloc_length;
-    share->default_values= table->record[1]+alloc_length;
-  }
-  table->setup_tmp_table_column_bitmaps(bitmaps);
-
-  record_info= start_record_info;
-  null_flags=(unsigned char*) table->record[0];
-  pos=table->record[0]+ null_pack_length;
-  if (null_pack_length)
-  {
-    memset(record_info, 0, sizeof(*record_info));
-    record_info->type=FIELD_NORMAL;
-    record_info->length=null_pack_length;
-    record_info++;
-    memset(null_flags, 255, null_pack_length);  // Set null fields
-
-    table->null_flags= (unsigned char*) table->record[0];
-    share->null_fields= null_count;
-    share->null_bytes= null_pack_length;
-  }
-  null_count=1;
-
-  {
-    //Field *field= *reg_field;
-    uint32_t length;
-    memset(record_info, 0, sizeof(*record_info));
-    field->move_field(pos,(unsigned char*) 0,0);
-
-    field->reset();
-    /*
-      Test if there is a default field value. The test for ->ptr is to skip
-      'offset' fields generated by initalize_tables
-    */
-    // Initialize the table field:
-    memset(field->ptr, 0, field->pack_length());
-
-    length=field->pack_length();
-    pos+= length;
-
-    /* Make entry for create table */
-    record_info->length=length;
-    if (field->flags & BLOB_FLAG)
-      record_info->type= (int) FIELD_BLOB;
-    else
-      record_info->type=FIELD_NORMAL;
-
-    field->table_name= &table->alias;
-  }
-
-  if (session->variables.tmp_table_size == ~ (uint64_t) 0)    // No limit
-    share->max_rows= ~(ha_rows) 0;
-  else
-    share->max_rows= (ha_rows) (((share->db_type() == heap_engine) ?
-                                 min(session->variables.tmp_table_size,
-                                     session->variables.max_heap_table_size) :
-                                 session->variables.tmp_table_size) /
-                                share->reclength);
-  set_if_bigger(share->max_rows,(ha_rows)1);    // For dummy start options
-
-
-  if (true)
-  {
-    share->keys=1;
-    share->uniques= test(using_unique_constraint);
-    table->key_info=keyinfo;
-    keyinfo->key_part=key_part_info;
-    keyinfo->flags=HA_NOSAME;
-    keyinfo->usable_key_parts= keyinfo->key_parts= 1;
-    keyinfo->key_length=0;
-    keyinfo->rec_per_key=0;
-    keyinfo->algorithm= HA_KEY_ALG_UNDEF;
-    keyinfo->name= (char*) "weedout_key";
-    {
-      key_part_info->null_bit=0;
-      key_part_info->field=  field;
-      key_part_info->offset= field->offset(table->record[0]);
-      key_part_info->length= (uint16_t) field->key_length();
-      key_part_info->type=   (uint8_t) field->key_type();
-      key_part_info->key_type = FIELDFLAG_BINARY;
-      if (!using_unique_constraint)
-      {
-        if (!(key_field= field->new_key_field(session->mem_root, table,
-                                              group_buff,
-                                              field->null_ptr,
-                                              field->null_bit)))
-          goto err;
-        key_part_info->key_part_flag|= HA_END_SPACE_ARE_EQUAL; //todo need this?
-      }
-      keyinfo->key_length+=  key_part_info->length;
-    }
-  }
-
-  if (session->is_fatal_error)        // If end of memory
-    goto err;
-  share->db_record_offset= 1;
-  if (share->db_type() == myisam_engine)
-  {
-    record_info++;
-    if (table->create_myisam_tmp_table(keyinfo, start_record_info, &record_info, 0))
-      goto err;
-  }
-  start_recinfo= start_record_info;
-  recinfo=       record_info;
-  if (table->open_tmp_table())
-    goto err;
-
-  session->mem_root= mem_root_save;
-  return table;
-
-err:
-  session->mem_root= mem_root_save;
-  table->free_tmp_table(session);                    /* purecov: inspected */
-  return NULL;        /* purecov: inspected */
-}
-
-/*
-  SemiJoinDuplicateElimination: Reset the temporary table
-*/
-int SemiJoinTable::reset()
-{
-  if (tmp_table)
-    return tmp_table->file->ha_delete_all_rows();
-
-  return 0;
-}
-

=== removed file 'drizzled/semi_join_table.h'
--- drizzled/semi_join_table.h	2009-07-11 07:38:37 +0000
+++ drizzled/semi_join_table.h	1970-01-01 00:00:00 +0000
@@ -1,71 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#ifndef DRIZZLED_SEMI_JOIN_TABLE_H
-#define DRIZZLED_SEMI_JOIN_TABLE_H
-
-#include <drizzled/server_includes.h>
-#include <drizzled/table.h>
-
-/*
-  Describes use of one temporary table to weed out join duplicates.
-  The temporar
-
-  Used to
-    - create a temp table
-    - when we reach the weed-out tab, walk through rowid-ed tabs and
-      and copy rowids.
-      For each table we need
-       - rowid offset
-       - null bit address.
-*/
-
-class SemiJoinTable : public Sql_alloc
-{
-public:
-  /* Array of pointers to tables that should be "used" */
-  class TAB
-  {
-  public:
-    JoinTable *join_tab;
-    uint32_t rowid_offset;
-    uint16_t null_byte;
-    unsigned char null_bit;
-  };
-  TAB *tabs;
-  TAB *tabs_end;
-
-  uint32_t null_bits;
-  uint32_t null_bytes;
-  uint32_t rowid_len;
-
-  Table *tmp_table;
-
-  MI_COLUMNDEF *start_recinfo;
-  MI_COLUMNDEF *recinfo;
-
-  /* Pointer to next table (next->start_idx > this->end_idx) */
-  SemiJoinTable *next;
-
-  Table *createTable(Session *session,
-                     uint32_t uniq_tuple_length_arg);
-  int reset();
-};
-
-#endif /* DRIZZLED_SEMI_JOIN_TABLE_H */

=== modified file 'drizzled/sql_select.cc'
--- drizzled/sql_select.cc	2009-07-28 23:31:50 +0000
+++ drizzled/sql_select.cc	2009-07-29 07:28:29 +0000
@@ -24,7 +24,6 @@
 */
 #include "drizzled/server_includes.h"
 #include "drizzled/sql_select.h" /* include join.h */
-#include "drizzled/semi_join_table.h"
 #include "drizzled/table_map_iterator.h"
 
 #include "drizzled/error.h"
@@ -402,12 +401,6 @@
     }
   }
 
-  if (join->flatten_subqueries())
-  {
-    err= 1;
-    goto err;
-  }
-
   if ((err= join->optimize()))
   {
     goto err;					// 1
@@ -440,29 +433,11 @@
   return(join->error);
 }
 
-int subq_sj_candidate_cmp(Item_in_subselect* const *el1,
-                          Item_in_subselect* const *el2)
-{
-  return ((*el1)->sj_convert_priority < (*el2)->sj_convert_priority) ? 1 :
-         ( ((*el1)->sj_convert_priority == (*el2)->sj_convert_priority)? 0 : -1);
-}
-
 inline Item *and_items(Item* cond, Item *item)
 {
   return (cond? (new Item_cond_and(cond, item)) : item);
 }
 
-static TableList *alloc_join_nest(Session *session)
-{
-  TableList *tbl;
-  if (!(tbl= (TableList*) session->calloc(ALIGN_SIZE(sizeof(TableList))+
-                                       sizeof(nested_join_st))))
-    return NULL;
-  tbl->nested_join= (nested_join_st*) ((unsigned char*)tbl +
-                                    ALIGN_SIZE(sizeof(TableList)));
-  return tbl;
-}
-
 static void fix_list_after_tbl_changes(Select_Lex *new_parent, List<TableList> *tlist)
 {
   List_iterator<TableList> it(*tlist);
@@ -476,367 +451,6 @@
   }
 }
 
-/*
-  Convert a subquery predicate into a TableList semi-join nest
-
-  SYNOPSIS
-    convert_subq_to_sj()
-       parent_join  Parent join, the one that has subq_pred in its WHERE/ON
-                    clause
-       subq_pred    Subquery predicate to be converted
-
-  DESCRIPTION
-    Convert a subquery predicate into a TableList semi-join nest. All the
-    prerequisites are already checked, so the conversion is always successfull.
-
-    Prepared Statements: the transformation is permanent:
-     - Changes in TableList structures are naturally permanent
-     - Item tree changes are performed on statement MEM_ROOT:
-        = we activate statement MEM_ROOT
-        = this function is called before the first fix_prepare_information
-          call.
-
-    This is intended because the criteria for subquery-to-sj conversion remain
-    constant for the lifetime of the Prepared Statement.
-
-  RETURN
-    false  OK
-    true   Out of memory error
-*/
-bool convert_subq_to_sj(JOIN *parent_join, Item_in_subselect *subq_pred)
-{
-  Select_Lex *parent_lex= parent_join->select_lex;
-  TableList *emb_tbl_nest= NULL;
-  List<TableList> *emb_join_list= &parent_lex->top_join_list;
-  Session *session= parent_join->session;
-
-  /*
-    1. Find out where to put the predicate into.
-     Note: for "t1 LEFT JOIN t2" this will be t2, a leaf.
-  */
-  if ((void*)subq_pred->expr_join_nest != (void*)1)
-  {
-    if (subq_pred->expr_join_nest->nested_join)
-    {
-      /*
-        We're dealing with
-
-          ... [LEFT] JOIN  ( ... ) ON (subquery AND whatever) ...
-
-        The sj-nest will be inserted into the brackets nest.
-      */
-      emb_tbl_nest=  subq_pred->expr_join_nest;
-      emb_join_list= &emb_tbl_nest->nested_join->join_list;
-    }
-    else if (!subq_pred->expr_join_nest->outer_join)
-    {
-      /*
-        We're dealing with
-
-          ... INNER JOIN tblX ON (subquery AND whatever) ...
-
-        The sj-nest will be tblX's "sibling", i.e. another child of its
-        parent. This is ok because tblX is joined as an inner join.
-      */
-      emb_tbl_nest= subq_pred->expr_join_nest->embedding;
-      if (emb_tbl_nest)
-        emb_join_list= &emb_tbl_nest->nested_join->join_list;
-    }
-    else if (!subq_pred->expr_join_nest->nested_join)
-    {
-      TableList *outer_tbl= subq_pred->expr_join_nest;
-      TableList *wrap_nest;
-      /*
-        We're dealing with
-
-          ... LEFT JOIN tbl ON (on_expr AND subq_pred) ...
-
-        we'll need to convert it into:
-
-          ... LEFT JOIN ( tbl SJ (subq_tables) ) ON (on_expr AND subq_pred) ...
-                        |                      |
-                        |<----- wrap_nest ---->|
-
-        Q:  other subqueries may be pointing to this element. What to do?
-        A1: simple solution: copy *subq_pred->expr_join_nest= *parent_nest.
-            But we'll need to fix other pointers.
-        A2: Another way: have TableList::next_ptr so the following
-            subqueries know the table has been nested.
-        A3: changes in the TableList::outer_join will make everything work
-            automatically.
-      */
-      if (!(wrap_nest= alloc_join_nest(parent_join->session)))
-      {
-        return(true);
-      }
-      wrap_nest->embedding= outer_tbl->embedding;
-      wrap_nest->join_list= outer_tbl->join_list;
-      wrap_nest->alias= (char*) "(sj-wrap)";
-
-      wrap_nest->nested_join->join_list.empty();
-      wrap_nest->nested_join->join_list.push_back(outer_tbl);
-
-      outer_tbl->embedding= wrap_nest;
-      outer_tbl->join_list= &wrap_nest->nested_join->join_list;
-
-      /*
-        wrap_nest will take place of outer_tbl, so move the outer join flag
-        and on_expr
-      */
-      wrap_nest->outer_join= outer_tbl->outer_join;
-      outer_tbl->outer_join= 0;
-
-      wrap_nest->on_expr= outer_tbl->on_expr;
-      outer_tbl->on_expr= NULL;
-
-      List_iterator<TableList> li(*wrap_nest->join_list);
-      TableList *tbl;
-      while ((tbl= li++))
-      {
-        if (tbl == outer_tbl)
-        {
-          li.replace(wrap_nest);
-          break;
-        }
-      }
-      /*
-        Ok now wrap_nest 'contains' outer_tbl and we're ready to add the
-        semi-join nest into it
-      */
-      emb_join_list= &wrap_nest->nested_join->join_list;
-      emb_tbl_nest=  wrap_nest;
-    }
-  }
-
-  TableList *sj_nest;
-  nested_join_st *nested_join;
-  if (!(sj_nest= alloc_join_nest(parent_join->session)))
-  {
-    return(true);
-  }
-  nested_join= sj_nest->nested_join;
-
-  sj_nest->join_list= emb_join_list;
-  sj_nest->embedding= emb_tbl_nest;
-  sj_nest->alias= (char*) "(sj-nest)";
-  /* Nests do not participate in those 'chains', so: */
-  /* sj_nest->next_leaf= sj_nest->next_local= sj_nest->next_global == NULL*/
-  emb_join_list->push_back(sj_nest);
-
-  /*
-    nested_join->used_tables and nested_join->not_null_tables are
-    initialized in simplify_joins().
-  */
-
-  /*
-    2. Walk through subquery's top list and set 'embedding' to point to the
-       sj-nest.
-  */
-  Select_Lex *subq_lex= subq_pred->unit->first_select();
-  nested_join->join_list.empty();
-  List_iterator_fast<TableList> li(subq_lex->top_join_list);
-  TableList *tl, *last_leaf;
-  while ((tl= li++))
-  {
-    tl->embedding= sj_nest;
-    tl->join_list= &nested_join->join_list;
-    nested_join->join_list.push_back(tl);
-  }
-
-  /*
-    Reconnect the next_leaf chain.
-    TODO: Do we have to put subquery's tables at the end of the chain?
-          Inserting them at the beginning would be a bit faster.
-    NOTE: We actually insert them at the front! That's because the order is
-          reversed in this list.
-  */
-  for (tl= parent_lex->leaf_tables; tl->next_leaf; tl= tl->next_leaf) {};
-  tl->next_leaf= subq_lex->leaf_tables;
-  last_leaf= tl;
-
-  /*
-    Same as above for next_local chain
-    (a theory: a next_local chain always starts with ::leaf_tables
-     because view's tables are inserted after the view)
-  */
-  for (tl= parent_lex->leaf_tables; tl->next_local; tl= tl->next_local) {};
-  tl->next_local= subq_lex->leaf_tables;
-
-  /* A theory: no need to re-connect the next_global chain */
-
-  /* 3. Remove the original subquery predicate from the WHERE/ON */
-
-  // The subqueries were replaced for Item_int(1) earlier
-  subq_pred->exec_method= Item_in_subselect::SEMI_JOIN; // for subsequent executions
-  /*TODO: also reset the 'with_subselect' there. */
-
-  /* n. Adjust the parent_join->tables counter */
-  uint32_t table_no= parent_join->tables;
-  /* n. Walk through child's tables and adjust table->map */
-  for (tl= subq_lex->leaf_tables; tl; tl= tl->next_leaf, table_no++)
-  {
-    tl->table->tablenr= table_no;
-    tl->table->map= ((table_map)1) << table_no;
-    Select_Lex *old_sl= tl->select_lex;
-    tl->select_lex= parent_join->select_lex;
-    for(TableList *emb= tl->embedding; emb && emb->select_lex == old_sl; emb= emb->embedding)
-      emb->select_lex= parent_join->select_lex;
-  }
-  parent_join->tables += subq_lex->join->tables;
-
-  /*
-    Put the subquery's WHERE into semi-join's sj_on_expr
-    Add the subquery-induced equalities too.
-  */
-  Select_Lex *save_lex= session->lex->current_select;
-  session->lex->current_select=subq_lex;
-  if (!subq_pred->left_expr->fixed &&
-       subq_pred->left_expr->fix_fields(session, &subq_pred->left_expr))
-    return(true);
-  session->lex->current_select=save_lex;
-
-  sj_nest->nested_join->sj_corr_tables= subq_pred->used_tables();
-  sj_nest->nested_join->sj_depends_on=  subq_pred->used_tables() |
-                                        subq_pred->left_expr->used_tables();
-  sj_nest->sj_on_expr= subq_lex->where;
-
-  /*
-    Create the IN-equalities and inject them into semi-join's ON expression.
-    Additionally, for InsideOut strategy
-     - Record the number of IN-equalities.
-     - Create list of pointers to (oe1, ..., ieN). We'll need the list to
-       see which of the expressions are bound and which are not (for those
-       we'll produce a distinct stream of (ie_i1,...ie_ik).
-
-       (TODO: can we just create a list of pointers and hope the expressions
-       will not substitute themselves on fix_fields()? or we need to wrap
-       them into Item_direct_view_refs and store pointers to those. The
-       pointers to Item_direct_view_refs are guaranteed to be stable as
-       Item_direct_view_refs doesn't substitute itself with anything in
-       Item_direct_view_ref::fix_fields.
-  */
-  sj_nest->sj_in_exprs= subq_pred->left_expr->cols();
-  sj_nest->nested_join->sj_outer_expr_list.empty();
-
-  if (subq_pred->left_expr->cols() == 1)
-  {
-    nested_join->sj_outer_expr_list.push_back(subq_pred->left_expr);
-
-    Item *item_eq= new Item_func_eq(subq_pred->left_expr,
-                                    subq_lex->ref_pointer_array[0]);
-    item_eq->name= (char*)subq_sj_cond_name;
-    sj_nest->sj_on_expr= and_items(sj_nest->sj_on_expr, item_eq);
-  }
-  else
-  {
-    for (uint32_t i= 0; i < subq_pred->left_expr->cols(); i++)
-    {
-      nested_join->sj_outer_expr_list.push_back(subq_pred->left_expr->
-                                                element_index(i));
-      Item *item_eq=
-        new Item_func_eq(subq_pred->left_expr->element_index(i),
-                         subq_lex->ref_pointer_array[i]);
-      item_eq->name= (char*)subq_sj_cond_name + (i % 64);
-      sj_nest->sj_on_expr= and_items(sj_nest->sj_on_expr, item_eq);
-    }
-  }
-  /* Fix the created equality and AND */
-  sj_nest->sj_on_expr->fix_fields(parent_join->session, &sj_nest->sj_on_expr);
-
-  /*
-    Walk through sj nest's WHERE and ON expressions and call
-    item->fix_table_changes() for all items.
-  */
-  sj_nest->sj_on_expr->fix_after_pullout(parent_lex, &sj_nest->sj_on_expr);
-  fix_list_after_tbl_changes(parent_lex, &sj_nest->nested_join->join_list);
-
-
-  /* Unlink the child select_lex so it doesn't show up in EXPLAIN: */
-  subq_lex->master_unit()->exclude_level();
-
-  /* Inject sj_on_expr into the parent's WHERE or ON */
-  if (emb_tbl_nest)
-  {
-    emb_tbl_nest->on_expr= and_items(emb_tbl_nest->on_expr,
-                                     sj_nest->sj_on_expr);
-    emb_tbl_nest->on_expr->fix_fields(parent_join->session, &emb_tbl_nest->on_expr);
-  }
-  else
-  {
-    /* Inject into the WHERE */
-    parent_join->conds= and_items(parent_join->conds, sj_nest->sj_on_expr);
-    parent_join->conds->fix_fields(parent_join->session, &parent_join->conds);
-    parent_join->select_lex->where= parent_join->conds;
-  }
-
-  return(false);
-}
-
-/*
-  Check if table's KeyUse elements have an eq_ref(outer_tables) candidate
-
-  SYNOPSIS
-    find_eq_ref_candidate()
-      table             Table to be checked
-      sj_inner_tables   Bitmap of inner tables. eq_ref(inner_table) doesn't
-                        count.
-
-  DESCRIPTION
-    Check if table's KeyUse elements have an eq_ref(outer_tables) candidate
-
-  TODO
-    Check again if it is feasible to factor common parts with constant table
-    search
-
-  RETURN
-    true  - There exists an eq_ref(outer-tables) candidate
-    false - Otherwise
-*/
-bool find_eq_ref_candidate(Table *table, table_map sj_inner_tables)
-{
-  KeyUse *keyuse= table->reginfo.join_tab->keyuse;
-  uint32_t key;
-
-  if (keyuse)
-  {
-    while (1) /* For each key */
-    {
-      key= keyuse->key;
-      KEY *keyinfo= table->key_info + key;
-      key_part_map bound_parts= 0;
-      if ((keyinfo->flags & HA_NOSAME) == HA_NOSAME)
-      {
-        do  /* For all equalities on all key parts */
-        {
-          /* Check if this is "t.keypart = expr(outer_tables) */
-          if (!(keyuse->used_tables & sj_inner_tables) &&
-              !(keyuse->optimize & KEY_OPTIMIZE_REF_OR_NULL))
-          {
-            bound_parts |= 1 << keyuse->keypart;
-          }
-          keyuse++;
-        } while (keyuse->key == key && keyuse->table == table);
-
-        if (bound_parts == PREV_BITS(uint, keyinfo->key_parts))
-          return true;
-        if (keyuse->table != table)
-          return false;
-      }
-      else
-      {
-        do
-        {
-          keyuse++;
-          if (keyuse->table != table)
-            return false;
-        }
-        while (keyuse->key == key);
-      }
-    }
-  }
-  return false;
-}
-
 /*****************************************************************************
   Create JoinTableS, make a guess about the table types,
   Approximate how many records will be used in each table
@@ -1166,9 +780,6 @@
                                   ((*value)->type() == Item::FIELD_ITEM) &&
                                   ((Item_field*)*value)->field->maybe_null());
   (*key_fields)->cond_guard= NULL;
-  (*key_fields)->sj_pred_no= (cond->name >= subq_sj_cond_name &&
-                              cond->name < subq_sj_cond_name + 64)?
-                              cond->name - subq_sj_cond_name: UINT_MAX;
   (*key_fields)++;
 }
 
@@ -1461,9 +1072,8 @@
           keyuse.keypart_map= (key_part_map) 1 << part;
           keyuse.used_tables=key_field->val->used_tables();
           keyuse.optimize= key_field->optimize & KEY_OPTIMIZE_REF_OR_NULL;
-                keyuse.null_rejecting= key_field->null_rejecting;
-                keyuse.cond_guard= key_field->cond_guard;
-                keyuse.sj_pred_no= key_field->sj_pred_no;
+          keyuse.null_rejecting= key_field->null_rejecting;
+          keyuse.cond_guard= key_field->cond_guard;
           insert_dynamic(keyuse_array,(unsigned char*) &keyuse);
         }
       }
@@ -1827,49 +1437,6 @@
     join_tab->const_keys|= possible_keys;
 }
 
-/*****************************************************************************
-  Go through all combinations of not marked tables and find the one
-  which uses least records
-*****************************************************************************/
-
-/*
-  Given a semi-join nest, find out which of the IN-equalities are bound
-
-  SYNOPSIS
-    get_bound_sj_equalities()
-      sj_nest           Semi-join nest
-      remaining_tables  Tables that are not yet bound
-
-  DESCRIPTION
-    Given a semi-join nest, find out which of the IN-equalities have their
-    left part expression bound (i.e. the said expression doesn't refer to
-    any of remaining_tables and can be evaluated).
-
-  RETURN
-    Bitmap of bound IN-equalities.
-*/
-uint64_t get_bound_sj_equalities(TableList *sj_nest, table_map remaining_tables)
-{
-  List_iterator<Item> li(sj_nest->nested_join->sj_outer_expr_list);
-  Item *item;
-  uint32_t i= 0;
-  uint64_t res= 0;
-  while ((item= li++))
-  {
-    /*
-      Q: should this take into account equality propagation and how?
-      A: If e->outer_side is an Item_field, walk over the equality
-         class and see if there is an element that is bound?
-      (this is an optional feature)
-    */
-    if (!(item->used_tables() & remaining_tables))
-    {
-      res |= 1UL < i;
-    }
-  }
-  return res;
-}
-
 /**
   Compare two JoinTable objects based on the number of accessed records.
 
@@ -4039,35 +3606,6 @@
   return false;
 }
 
-void advance_sj_state(const table_map remaining_tables, const JoinTable *tab)
-{
-  TableList *emb_sj_nest;
-  if ((emb_sj_nest= tab->emb_sj_nest))
-  {
-    tab->join->cur_emb_sj_nests |= emb_sj_nest->sj_inner_tables;
-    /* Remove the sj_nest if all of its SJ-inner tables are in cur_table_map */
-    if (!(remaining_tables & emb_sj_nest->sj_inner_tables))
-      tab->join->cur_emb_sj_nests &= ~emb_sj_nest->sj_inner_tables;
-  }
-}
-
-/*
-  we assume remaining_tables doesnt contain @tab.
-*/
-void restore_prev_sj_state(const table_map remaining_tables, const JoinTable *tab)
-{
-  TableList *emb_sj_nest;
-  if ((emb_sj_nest= tab->emb_sj_nest))
-  {
-    /* If we're removing the last SJ-inner table, remove the sj-nest */
-    if ((remaining_tables & emb_sj_nest->sj_inner_tables) ==
-        (emb_sj_nest->sj_inner_tables & ~tab->table->map))
-    {
-      tab->join->cur_emb_sj_nests &= ~emb_sj_nest->sj_inner_tables;
-    }
-  }
-}
-
 COND *optimize_cond(JOIN *join, COND *conds, List<TableList> *join_list, Item::cond_result *cond_value)
 {
   Session *session= join->session;
@@ -4700,11 +4238,6 @@
   enum_nested_loop_state rc;
   READ_RECORD *info= &join_tab->read_record;
 
-  if (join_tab->flush_weedout_table)
-  {
-    join_tab->flush_weedout_table->reset();
-  }
-
   if (join->resume_nested_loop)
   {
     /* If not the last table, plunge down the nested loop */
@@ -8138,28 +7671,6 @@
           extra.append(STRING_WITH_LEN("; LooseScan"));
         }
 
-        if (tab->flush_weedout_table)
-          extra.append(STRING_WITH_LEN("; Start temporary"));
-        else if (tab->check_weed_out_table)
-          extra.append(STRING_WITH_LEN("; End temporary"));
-        else if (tab->do_firstmatch)
-        {
-          extra.append(STRING_WITH_LEN("; FirstMatch("));
-          Table *prev_table=tab->do_firstmatch->table;
-          if (prev_table->derived_select_number)
-          {
-            char namebuf[NAME_LEN];
-            /* Derived table name generation */
-            int len= snprintf(namebuf, sizeof(namebuf)-1,
-                              "<derived%u>",
-                              prev_table->derived_select_number);
-            extra.append(namebuf, len);
-          }
-          else
-            extra.append(prev_table->pos_in_table_list->alias);
-          extra.append(STRING_WITH_LEN(")"));
-        }
-
         for (uint32_t part= 0; part < tab->ref.key_parts; part++)
         {
           if (tab->ref.cond_guards[part])
@@ -8268,8 +7779,6 @@
     }
     else if (curr->straight)
       str->append(STRING_WITH_LEN(" straight_join "));
-    else if (curr->sj_inner_tables)
-      str->append(STRING_WITH_LEN(" semi join "));
     else
       str->append(STRING_WITH_LEN(" join "));
     curr->print(session, str, QT_ORDINARY);
@@ -8301,25 +7810,6 @@
 
   for (TableList **t= table + (tables->elements - 1); t >= table; t--)
     *t= ti++;
-
-  /*
-    If the first table is a semi-join nest, swap it with something that is
-    not a semi-join nest.
-  */
-  if ((*table)->sj_inner_tables)
-  {
-    TableList **end= table + tables->elements;
-    for (TableList **t2= table; t2!=end; t2++)
-    {
-      if (!(*t2)->sj_inner_tables)
-      {
-        TableList *tmp= *t2;
-        *t2= *table;
-        *table= tmp;
-        break;
-      }
-    }
-  }
   assert(tables->elements >= 1);
   print_table_array(session, str, table, table + tables->elements);
 }

=== modified file 'drizzled/sql_select.h'
--- drizzled/sql_select.h	2009-07-11 19:23:04 +0000
+++ drizzled/sql_select.h	2009-07-29 07:28:29 +0000
@@ -72,11 +72,6 @@
     NULL  - Otherwise (the source equality can't be turned off)
   */
   bool *cond_guard;
-  /**
-     0..64    <=> This was created from semi-join IN-equality # sj_pred_no.
-     MAX_UINT  Otherwise
-  */
-  uint32_t sj_pred_no;
 };
 
 class JOIN;
@@ -164,7 +159,6 @@
   */
   bool null_rejecting;
   bool *cond_guard; /**< @see KeyUse::cond_guard */
-  uint32_t sj_pred_no; /**< @see KeyUse::sj_pred_no */
 } KEY_FIELD;
 
 /*****************************************************************************
@@ -226,8 +220,6 @@
 int do_select(JOIN *join, List<Item> *fields, Table *tmp_table);
 bool const_expression_in_where(COND *conds,Item *item, Item **comp_item);
 int create_sort_index(Session *session, JOIN *join, order_st *order, ha_rows filesort_limit, ha_rows select_limit, bool is_order_by);
-void advance_sj_state(const table_map remaining_tables, const JoinTable *tab);
-void restore_prev_sj_state(const table_map remaining_tables, const JoinTable *tab);
 void save_index_subquery_explain_info(JoinTable *join_tab, Item* where);
 Item *remove_additional_cond(Item* conds);
 bool setup_sum_funcs(Session *session, Item_sum **func_ptr);
@@ -241,8 +233,6 @@
                                uint32_t elements,
 			                         List<Item> &all_fields);
 void select_describe(JOIN *join, bool need_tmp_table,bool need_order, bool distinct, const char *message= NULL);
-int subq_sj_candidate_cmp(Item_in_subselect* const *el1, Item_in_subselect* const *el2);
-bool convert_subq_to_sj(JOIN *parent_join, Item_in_subselect *subq_pred);
 bool change_group_ref(Session *session, Item_func *expr, order_st *group_list, bool *changed);
 bool check_interleaving_with_nj(JoinTable *last, JoinTable *next);
 
@@ -288,7 +278,6 @@
                                 List<Item> &all_fields,
                                 bool *all_order_by_fields_used);
 bool eq_ref_table(JOIN *join, order_st *start_order, JoinTable *tab);
-uint64_t get_bound_sj_equalities(TableList *sj_nest, table_map remaining_tables);
 int join_tab_cmp(const void* ptr1, const void* ptr2);
 int remove_dup_with_compare(Session *session, Table *table, Field **first_field, uint32_t offset, Item *having);
 int remove_dup_with_hash_index(Session *session, 
@@ -313,7 +302,6 @@
 // Create list for using with tempory table
 void init_tmptable_sum_functions(Item_sum **func);
 void update_tmptable_sum_func(Item_sum **func,Table *tmp_table);
-bool find_eq_ref_candidate(Table *table, table_map sj_inner_tables);
 bool only_eq_ref_tables(JOIN *join, order_st *order, table_map tables);
 bool create_ref_for_key(JOIN *join, JoinTable *j, KeyUse *org_keyuse, table_map used_tables);
 

=== modified file 'drizzled/sql_union.cc'
--- drizzled/sql_union.cc	2009-05-29 23:52:19 +0000
+++ drizzled/sql_union.cc	2009-07-28 17:52:18 +0000
@@ -447,9 +447,6 @@
           (select_limit_cnt == HA_POS_ERROR || sl->braces) ?
           sl->options & ~OPTION_FOUND_ROWS : sl->options | found_rows_for_union;
 
-        if (sl->join->flatten_subqueries())
-          return(true);
-
 	saved_error= sl->join->optimize();
       }
       if (!saved_error)

=== modified file 'drizzled/table.cc'
--- drizzled/table.cc	2009-07-28 16:53:59 +0000
+++ drizzled/table.cc	2009-07-29 06:03:18 +0000
@@ -20,7 +20,6 @@
 #include <drizzled/error.h>
 #include <drizzled/gettext.h>
 
-#include <drizzled/semi_join_table.h>
 #include <drizzled/nested_join.h>
 #include <drizzled/sql_parse.h>
 #include <drizzled/item/sum.h>

=== modified file 'drizzled/table_list.h'
--- drizzled/table_list.h	2009-06-08 06:23:32 +0000
+++ drizzled/table_list.h	2009-07-28 23:50:18 +0000
@@ -81,9 +81,6 @@
     schema_table_name(NULL),
     option(NULL),
     on_expr(NULL),
-    sj_on_expr(NULL),
-    sj_inner_tables(0),
-    sj_in_exprs(0),
     table_id(0),
     table(NULL),
     prep_on_expr(NULL),
@@ -147,16 +144,6 @@
   char		*schema_table_name;
   char    *option;                /* Used by cache index  */
   Item		*on_expr;		/* Used with outer join */
-  Item          *sj_on_expr;
-  /*
-    (Valid only for semi-join nests) Bitmap of tables that are within the
-    semi-join (this is different from bitmap of all nest's children because
-    tables that were pulled out of the semi-join nest remain listed as
-    nest's children).
-  */
-  table_map     sj_inner_tables;
-  /* Number of IN-compared expressions */
-  uint32_t          sj_in_exprs;
   uint32_t          table_id; /* table id (from binlog) for opened table */
   Table        *table;    /* opened table */
   /*

=== modified file 'tests/r/group_by.result'
--- tests/r/group_by.result	2009-06-16 00:53:22 +0000
+++ tests/r/group_by.result	2009-07-28 17:52:18 +0000
@@ -1394,8 +1394,8 @@
 EXPLAIN SELECT 1 FROM t1 WHERE a IN
 (SELECT a FROM t1 USE INDEX (i2) IGNORE INDEX (i2));
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	144	Start temporary
-1	PRIMARY	t1	eq_ref	PRIMARY,i2	PRIMARY	4	test.t1.a	1	Using index; End temporary
+1	PRIMARY	t1	index	NULL	PRIMARY	4	NULL	144	Using where; Using index
+2	SUBQUERY	t1	ALL	NULL	NULL	NULL	NULL	144	
 CREATE TABLE t2 (a INT, b INT, KEY(a));
 INSERT INTO t2 VALUES (1, 1), (2, 2), (3,3), (4,4);
 EXPLAIN SELECT a, SUM(b) FROM t2 GROUP BY a LIMIT 2;
@@ -1407,8 +1407,8 @@
 EXPLAIN SELECT 1 FROM t2 WHERE a IN
 (SELECT a FROM t1 USE INDEX (i2) IGNORE INDEX (i2));
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t2	index	a	a	5	NULL	4	Using index; Start temporary
-1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	144	Using where; End temporary; Using join buffer
+1	PRIMARY	t2	index	NULL	a	5	NULL	4	Using where; Using index
+2	SUBQUERY	t1	ALL	NULL	NULL	NULL	NULL	144	
 DROP TABLE t1, t2;
 CREATE TABLE t1(
 a INT, 

=== modified file 'tests/r/information_schema.result'
--- tests/r/information_schema.result	2009-07-05 18:46:45 +0000
+++ tests/r/information_schema.result	2009-07-29 07:11:15 +0000
@@ -823,7 +823,6 @@
 #	#
 #	#
 #	#
-#	#
 SHOW STATUS;
 Variable_name	Value
 #	#
@@ -933,7 +932,6 @@
 #	#
 #	#
 #	#
-#	#
 SELECT *
 FROM information_schema.global_status
 ORDER BY variable_name;
@@ -1045,7 +1043,6 @@
 #	#
 #	#
 #	#
-#	#
 SELECT *
 FROM information_schema.table_constraints;
 CONSTRAINT_CATALOG	CONSTRAINT_SCHEMA	CONSTRAINT_NAME	TABLE_SCHEMA	TABLE_NAME	CONSTRAINT_TYPE

=== modified file 'tests/r/subselect.result'
--- tests/r/subselect.result	2009-06-17 06:15:17 +0000
+++ tests/r/subselect.result	2009-07-28 17:52:18 +0000
@@ -1266,31 +1266,31 @@
 4
 explain extended select * from t2 where t2.a in (select a from t1);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	PRIMARY	PRIMARY	4	NULL	4	100.00	Using index
-1	PRIMARY	t1	index	PRIMARY	PRIMARY	4	NULL	4	75.00	Using where; Using index; Using join buffer
+1	PRIMARY	t2	index	NULL	PRIMARY	4	NULL	4	100.00	Using where; Using index
+2	SUBQUERY	t1	index	NULL	PRIMARY	4	NULL	4	100.00	Using index
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from (`test`.`t1`) join `test`.`t2` where (`test`.`t1`.`a` = `test`.`t2`.`a`)
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,`test`.`t2`.`a` in ( <materialize> (select `test`.`t1`.`a` AS `a` from `test`.`t1` ), <primary_index_lookup>(`test`.`t2`.`a` in <temporary table> on distinct_key)))
 select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 a
 2
 4
 explain extended select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	PRIMARY	PRIMARY	4	NULL	4	100.00	Using index
-1	PRIMARY	t1	ALL	PRIMARY	NULL	NULL	NULL	4	75.00	Using where; Using join buffer
+1	PRIMARY	t2	index	NULL	PRIMARY	4	NULL	4	100.00	Using where; Using index
+2	SUBQUERY	t1	ALL	NULL	NULL	NULL	NULL	4	100.00	Using where
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from (`test`.`t1`) join `test`.`t2` where ((`test`.`t1`.`a` = `test`.`t2`.`a`) and (`test`.`t1`.`b` <> 30))
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,`test`.`t2`.`a` in ( <materialize> (select `test`.`t1`.`a` AS `a` from `test`.`t1` where (`test`.`t1`.`b` <> 30) ), <primary_index_lookup>(`test`.`t2`.`a` in <temporary table> on distinct_key)))
 select * from t2 where t2.a in (select t1.a from t1,t3 where t1.b=t3.a);
 a
 2
 3
 explain extended select * from t2 where t2.a in (select t1.a from t1,t3 where t1.b=t3.a);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	PRIMARY	PRIMARY	4	NULL	4	100.00	Using index
-1	PRIMARY	t1	ALL	PRIMARY	NULL	NULL	NULL	4	75.00	Using where; Using join buffer
-1	PRIMARY	t3	eq_ref	PRIMARY	PRIMARY	4	test.t1.b	1	100.00	Using index
+1	PRIMARY	t2	index	NULL	PRIMARY	4	NULL	4	100.00	Using where; Using index
+2	SUBQUERY	t3	index	PRIMARY	PRIMARY	4	NULL	3	100.00	Using index
+2	SUBQUERY	t1	ALL	NULL	NULL	NULL	NULL	4	100.00	Using where; Using join buffer
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from (`test`.`t1` join `test`.`t3`) join `test`.`t2` where ((`test`.`t1`.`a` = `test`.`t2`.`a`) and (`test`.`t3`.`a` = `test`.`t1`.`b`))
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,`test`.`t2`.`a` in ( <materialize> (select `test`.`t1`.`a` AS `a` from `test`.`t1` join `test`.`t3` where (`test`.`t1`.`b` = `test`.`t3`.`a`) ), <primary_index_lookup>(`test`.`t2`.`a` in <temporary table> on distinct_key)))
 drop table t1, t2, t3;
 create temporary table t1 (a int, b int, index a (a,b)) ENGINE=MyISAM;
 create temporary table t2 (a int, index a (a)) ENGINE=MyISAM;
@@ -1306,31 +1306,31 @@
 4
 explain extended select * from t2 where t2.a in (select a from t1);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	a	a	5	NULL	4	100.00	Using index
-1	PRIMARY	t1	ref	a	a	5	test.t2.a	101	100.00	Using index; FirstMatch(t2)
+1	PRIMARY	t2	index	NULL	a	5	NULL	4	100.00	Using where; Using index
+2	SUBQUERY	t1	index	NULL	a	10	NULL	10004	100.00	Using index
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` semi join (`test`.`t1`) where (`test`.`t1`.`a` = `test`.`t2`.`a`)
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,`test`.`t2`.`a` in ( <materialize> (select `test`.`t1`.`a` AS `a` from `test`.`t1` ), <primary_index_lookup>(`test`.`t2`.`a` in <temporary table> on distinct_key)))
 select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 a
 2
 4
 explain extended select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	a	a	5	NULL	4	100.00	Using index
-1	PRIMARY	t1	ref	a	a	5	test.t2.a	101	100.00	Using where; Using index; FirstMatch(t2)
+1	PRIMARY	t2	index	NULL	a	5	NULL	4	100.00	Using where; Using index
+2	SUBQUERY	t1	index	NULL	a	10	NULL	10004	100.00	Using where; Using index
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` semi join (`test`.`t1`) where ((`test`.`t1`.`a` = `test`.`t2`.`a`) and (`test`.`t1`.`b` <> 30))
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,`test`.`t2`.`a` in ( <materialize> (select `test`.`t1`.`a` AS `a` from `test`.`t1` where (`test`.`t1`.`b` <> 30) ), <primary_index_lookup>(`test`.`t2`.`a` in <temporary table> on distinct_key)))
 select * from t2 where t2.a in (select t1.a from t1,t3 where t1.b=t3.a);
 a
 2
 3
 explain extended select * from t2 where t2.a in (select t1.a from t1,t3 where t1.b=t3.a);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	a	a	5	NULL	4	100.00	Using index; Start temporary
-1	PRIMARY	t1	ref	a	a	5	test.t2.a	101	100.00	Using index; FirstMatch(t2)
-1	PRIMARY	t3	index	a	a	5	NULL	3	100.00	Using where; Using index; End temporary; Using join buffer
+1	PRIMARY	t2	index	NULL	a	5	NULL	4	100.00	Using where; Using index
+2	SUBQUERY	t3	index	a	a	5	NULL	3	100.00	Using index
+2	SUBQUERY	t1	index	NULL	a	10	NULL	10004	100.00	Using where; Using index; Using join buffer
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` semi join (`test`.`t1` join `test`.`t3`) where ((`test`.`t1`.`a` = `test`.`t2`.`a`) and (`test`.`t3`.`a` = `test`.`t1`.`b`))
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,`test`.`t2`.`a` in ( <materialize> (select `test`.`t1`.`a` AS `a` from `test`.`t1` join `test`.`t3` where (`test`.`t1`.`b` = `test`.`t3`.`a`) ), <primary_index_lookup>(`test`.`t2`.`a` in <temporary table> on distinct_key)))
 insert into t1 values (3,31);
 select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 a
@@ -1343,10 +1343,10 @@
 4
 explain extended select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	a	a	5	NULL	4	100.00	Using index
-1	PRIMARY	t1	ref	a	a	5	test.t2.a	101	100.00	Using where; Using index; FirstMatch(t2)
+1	PRIMARY	t2	index	NULL	a	5	NULL	4	100.00	Using where; Using index
+2	SUBQUERY	t1	index	NULL	a	10	NULL	10005	100.00	Using where; Using index
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` semi join (`test`.`t1`) where ((`test`.`t1`.`a` = `test`.`t2`.`a`) and (`test`.`t1`.`b` <> 30))
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,`test`.`t2`.`a` in ( <materialize> (select `test`.`t1`.`a` AS `a` from `test`.`t1` where (`test`.`t1`.`b` <> 30) ), <primary_index_lookup>(`test`.`t2`.`a` in <temporary table> on distinct_key)))
 drop table t1, t2, t3;
 #
 # alloc_group_fields() working
@@ -2813,10 +2813,10 @@
 Note	1003	select `test`.`t1`.`one` AS `one`,`test`.`t1`.`two` AS `two`,<in_optimizer>((`test`.`t1`.`one`,`test`.`t1`.`two`),<exists>(select `test`.`t2`.`one` AS `one`,`test`.`t2`.`two` AS `two` from `test`.`t2` where ((`test`.`t2`.`flag` = '0') and trigcond(((<cache>(`test`.`t1`.`one`) = `test`.`t2`.`one`) or isnull(`test`.`t2`.`one`))) and trigcond(((<cache>(`test`.`t1`.`two`) = `test`.`t2`.`two`) or isnull(`test`.`t2`.`two`)))) having (trigcond(<is_not_null_test>(`test`.`t2`.`one`)) and trigcond(<is_not_null_test>(`test`.`t2`.`two`))))) AS `test` from `test`.`t1`
 explain extended SELECT one,two from t1 where ROW(one,two) IN (SELECT one,two FROM t2 WHERE flag = 'N');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	8	100.00	Start temporary
-1	PRIMARY	t2	ALL	NULL	NULL	NULL	NULL	9	100.00	Using where; End temporary; Using join buffer
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	8	100.00	Using where
+2	SUBQUERY	t2	ALL	NULL	NULL	NULL	NULL	9	100.00	Using where
 Warnings:
-Note	1003	select `test`.`t1`.`one` AS `one`,`test`.`t1`.`two` AS `two` from `test`.`t1` semi join (`test`.`t2`) where ((`test`.`t2`.`two` = `test`.`t1`.`two`) and (`test`.`t2`.`one` = `test`.`t1`.`one`) and (`test`.`t2`.`flag` = 'N'))
+Note	1003	select `test`.`t1`.`one` AS `one`,`test`.`t1`.`two` AS `two` from `test`.`t1` where <in_optimizer>((`test`.`t1`.`one`,`test`.`t1`.`two`),(`test`.`t1`.`one`,`test`.`t1`.`two`) in ( <materialize> (select `test`.`t2`.`one` AS `one`,`test`.`t2`.`two` AS `two` from `test`.`t2` where (`test`.`t2`.`flag` = 'N') ), <primary_index_lookup>(`test`.`t1`.`one` in <temporary table> on distinct_key)))
 explain extended SELECT one,two,ROW(one,two) IN (SELECT one,two FROM t2 WHERE flag = '0' group by one,two) as 'test' from t1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
 1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	8	100.00	
@@ -4113,31 +4113,39 @@
 INSERT INTO t1 VALUES ('a', 'aaa');
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1);
 a	b
+a	aa
+a	aaa
 CREATE INDEX I1 ON t1 (a);
 CREATE INDEX I2 ON t1 (b);
 EXPLAIN SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	index	I1	I1	7	NULL	#	Using index; LooseScan
-1	PRIMARY	t1	ref	I2	I2	43	test.t1.a	#	Using where
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	#	Using where
+2	SUBQUERY	t1	index	NULL	I1	7	NULL	#	Using index
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1);
 a	b
+a	aa
+a	aaa
 CREATE TABLE t2 (a VARCHAR(1), b VARCHAR(10));
 INSERT INTO t2 SELECT * FROM t1;
 CREATE INDEX I1 ON t2 (a);
 CREATE INDEX I2 ON t2 (b);
 EXPLAIN SELECT a,b FROM t2 WHERE b IN (SELECT a FROM t2);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t2	index	I1	I1	7	NULL	#	Using index; LooseScan
-1	PRIMARY	t2	ref	I2	I2	43	test.t2.a	#	Using where
+1	PRIMARY	t2	ALL	NULL	NULL	NULL	NULL	#	Using where
+2	SUBQUERY	t2	index	NULL	I1	7	NULL	#	Using index
 SELECT a,b FROM t2 WHERE b IN (SELECT a FROM t2);
 a	b
+a	aa
+a	aaa
 EXPLAIN
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1 WHERE LENGTH(a)<500);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	index	I1	I1	7	NULL	#	Using where; Using index; LooseScan
-1	PRIMARY	t1	ref	I2	I2	43	test.t1.a	#	Using where
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	#	Using where
+2	SUBQUERY	t1	index	NULL	I1	7	NULL	#	Using where; Using index
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1 WHERE LENGTH(a)<500);
 a	b
+a	aa
+a	aaa
 DROP TABLE t1,t2;
 #
 # Bug #32400: Complex SELECT query returns correct result only on some

=== modified file 'tests/r/subselect2.result'
--- tests/r/subselect2.result	2009-02-28 20:43:31 +0000
+++ tests/r/subselect2.result	2009-07-28 17:52:18 +0000
@@ -123,11 +123,11 @@
 1	PRIMARY	t2	ALL	DDOCTYPEID_IDX	NULL	NULL	NULL	9	Using where
 1	PRIMARY	t1	eq_ref	PRIMARY	PRIMARY	130	test.t2.DOCID	1	
 1	PRIMARY	t4	eq_ref	PRIMARY	PRIMARY	130	test.t2.DOCTYPEID	1	
-2	DEPENDENT SUBQUERY	t3	eq_ref	PRIMARY,FFOLDERID_IDX,CMFLDRPARNT_IDX	PRIMARY	130	func	1	Using where
-2	DEPENDENT SUBQUERY	t3	eq_ref	PRIMARY,FFOLDERID_IDX,CMFLDRPARNT_IDX	PRIMARY	130	test.t3.PARENTID	1	Using where
-2	DEPENDENT SUBQUERY	t3	eq_ref	PRIMARY,FFOLDERID_IDX,CMFLDRPARNT_IDX	PRIMARY	130	test.t3.PARENTID	1	Using where
-2	DEPENDENT SUBQUERY	t3	eq_ref	PRIMARY,FFOLDERID_IDX,CMFLDRPARNT_IDX	PRIMARY	130	test.t3.PARENTID	1	Using where
-2	DEPENDENT SUBQUERY	t3	eq_ref	PRIMARY,FFOLDERID_IDX,CMFLDRPARNT_IDX	PRIMARY	130	test.t3.PARENTID	1	Using where
+2	SUBQUERY	t3	ALL	NULL	NULL	NULL	NULL	21	Using where
+3	SUBQUERY	t3	ALL	NULL	NULL	NULL	NULL	21	Using where
+4	SUBQUERY	t3	ALL	NULL	NULL	NULL	NULL	21	Using where
+5	SUBQUERY	t3	ALL	NULL	NULL	NULL	NULL	21	Using where
+6	SUBQUERY	t3	ref	CMFLDRPARNT_IDX	CMFLDRPARNT_IDX	131	const	6	Using where
 drop table t1, t2, t3, t4;
 CREATE TABLE t1 (a int, PRIMARY KEY (a)) Engine=InnoDB;
 INSERT INTO t1 VALUES (1),(2);

=== modified file 'tests/r/subselect3.result'
--- tests/r/subselect3.result	2008-12-06 22:41:03 +0000
+++ tests/r/subselect3.result	2009-07-28 17:52:18 +0000
@@ -99,7 +99,7 @@
 1	1
 show status like '%Handler_read_rnd_next';
 Variable_name	Value
-Handler_read_rnd_next	11
+Handler_read_rnd_next	5
 delete from t2;
 insert into t2 values (NULL, 0),(NULL, 0), (NULL, 0), (NULL, 0);
 flush status;
@@ -515,8 +515,8 @@
 dd	1	NULL	0
 select oref, a, b from t2 where (a,b) in (select ie1,ie2 from t1 where oref=t2.oref);
 oref	a	b
+ff	2	2
 aa	1	1
-ff	2	2
 select oref, a, b from t2 where (a,b) not in (select ie1,ie2 from t1 where oref=t2.oref);
 oref	a	b
 bb	2	1
@@ -560,8 +560,8 @@
 dd	1	NULL	0
 select oref, a, b from t2 where (a,b) in (select ie1,ie2 from t1 where oref=t2.oref);
 oref	a	b
+ff	2	2
 aa	1	1
-ff	2	2
 select oref, a, b from t2 where (a,b) not in (select ie1,ie2 from t1 where oref=t2.oref);
 oref	a	b
 bb	2	1

=== modified file 'tests/r/subselect_no_mat.result'
--- tests/r/subselect_no_mat.result	2009-06-17 06:15:49 +0000
+++ tests/r/subselect_no_mat.result	2009-07-28 17:52:18 +0000
@@ -1270,31 +1270,31 @@
 4
 explain extended select * from t2 where t2.a in (select a from t1);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	PRIMARY	PRIMARY	4	NULL	4	100.00	Using index
-1	PRIMARY	t1	index	PRIMARY	PRIMARY	4	NULL	4	75.00	Using where; Using index; Using join buffer
+1	PRIMARY	t2	index	NULL	PRIMARY	4	NULL	4	100.00	Using where; Using index
+2	DEPENDENT SUBQUERY	t1	unique_subquery	PRIMARY	PRIMARY	4	func	1	100.00	Using index
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from (`test`.`t1`) join `test`.`t2` where (`test`.`t1`.`a` = `test`.`t2`.`a`)
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,<exists>(<primary_index_lookup>(<cache>(`test`.`t2`.`a`) in t1 on PRIMARY)))
 select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 a
 2
 4
 explain extended select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	PRIMARY	PRIMARY	4	NULL	4	100.00	Using index
-1	PRIMARY	t1	ALL	PRIMARY	NULL	NULL	NULL	4	75.00	Using where; Using join buffer
+1	PRIMARY	t2	index	NULL	PRIMARY	4	NULL	4	100.00	Using where; Using index
+2	DEPENDENT SUBQUERY	t1	unique_subquery	PRIMARY	PRIMARY	4	func	1	100.00	Using where
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from (`test`.`t1`) join `test`.`t2` where ((`test`.`t1`.`a` = `test`.`t2`.`a`) and (`test`.`t1`.`b` <> 30))
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,<exists>(<primary_index_lookup>(<cache>(`test`.`t2`.`a`) in t1 on PRIMARY where ((`test`.`t1`.`b` <> 30) and (<cache>(`test`.`t2`.`a`) = `test`.`t1`.`a`)))))
 select * from t2 where t2.a in (select t1.a from t1,t3 where t1.b=t3.a);
 a
 2
 3
 explain extended select * from t2 where t2.a in (select t1.a from t1,t3 where t1.b=t3.a);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	PRIMARY	PRIMARY	4	NULL	4	100.00	Using index
-1	PRIMARY	t1	ALL	PRIMARY	NULL	NULL	NULL	4	75.00	Using where; Using join buffer
-1	PRIMARY	t3	eq_ref	PRIMARY	PRIMARY	4	test.t1.b	1	100.00	Using index
+1	PRIMARY	t2	index	NULL	PRIMARY	4	NULL	4	100.00	Using where; Using index
+2	DEPENDENT SUBQUERY	t1	eq_ref	PRIMARY	PRIMARY	4	func	1	100.00	
+2	DEPENDENT SUBQUERY	t3	eq_ref	PRIMARY	PRIMARY	4	test.t1.b	1	100.00	Using index
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from (`test`.`t1` join `test`.`t3`) join `test`.`t2` where ((`test`.`t1`.`a` = `test`.`t2`.`a`) and (`test`.`t3`.`a` = `test`.`t1`.`b`))
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,<exists>(select 1 AS `Not_used` from `test`.`t1` join `test`.`t3` where ((`test`.`t3`.`a` = `test`.`t1`.`b`) and (<cache>(`test`.`t2`.`a`) = `test`.`t1`.`a`))))
 drop table t1, t2, t3;
 create temporary table t1 (a int, b int, index a (a,b)) ENGINE=MyISAM;
 create temporary table t2 (a int, index a (a)) ENGINE=MyISAM;
@@ -1310,31 +1310,31 @@
 4
 explain extended select * from t2 where t2.a in (select a from t1);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	a	a	5	NULL	4	100.00	Using index
-1	PRIMARY	t1	ref	a	a	5	test.t2.a	101	100.00	Using index; FirstMatch(t2)
+1	PRIMARY	t2	index	NULL	a	5	NULL	4	100.00	Using where; Using index
+2	DEPENDENT SUBQUERY	t1	index_subquery	a	a	5	func	1001	100.00	Using index
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` semi join (`test`.`t1`) where (`test`.`t1`.`a` = `test`.`t2`.`a`)
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,<exists>(<index_lookup>(<cache>(`test`.`t2`.`a`) in t1 on a)))
 select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 a
 2
 4
 explain extended select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	a	a	5	NULL	4	100.00	Using index
-1	PRIMARY	t1	ref	a	a	5	test.t2.a	101	100.00	Using where; Using index; FirstMatch(t2)
+1	PRIMARY	t2	index	NULL	a	5	NULL	4	100.00	Using where; Using index
+2	DEPENDENT SUBQUERY	t1	index_subquery	a	a	5	func	1001	100.00	Using index; Using where
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` semi join (`test`.`t1`) where ((`test`.`t1`.`a` = `test`.`t2`.`a`) and (`test`.`t1`.`b` <> 30))
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,<exists>(<index_lookup>(<cache>(`test`.`t2`.`a`) in t1 on a where ((`test`.`t1`.`b` <> 30) and (<cache>(`test`.`t2`.`a`) = `test`.`t1`.`a`)))))
 select * from t2 where t2.a in (select t1.a from t1,t3 where t1.b=t3.a);
 a
 2
 3
 explain extended select * from t2 where t2.a in (select t1.a from t1,t3 where t1.b=t3.a);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	a	a	5	NULL	4	100.00	Using index; Start temporary
-1	PRIMARY	t1	ref	a	a	5	test.t2.a	101	100.00	Using index; FirstMatch(t2)
-1	PRIMARY	t3	index	a	a	5	NULL	3	100.00	Using where; Using index; End temporary; Using join buffer
+1	PRIMARY	t2	index	NULL	a	5	NULL	4	100.00	Using where; Using index
+2	DEPENDENT SUBQUERY	t1	ref	a	a	5	func	1001	100.00	Using index
+2	DEPENDENT SUBQUERY	t3	index	a	a	5	NULL	3	100.00	Using where; Using index; Using join buffer
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` semi join (`test`.`t1` join `test`.`t3`) where ((`test`.`t1`.`a` = `test`.`t2`.`a`) and (`test`.`t3`.`a` = `test`.`t1`.`b`))
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,<exists>(select 1 AS `Not_used` from `test`.`t1` join `test`.`t3` where ((`test`.`t3`.`a` = `test`.`t1`.`b`) and (<cache>(`test`.`t2`.`a`) = `test`.`t1`.`a`))))
 insert into t1 values (3,31);
 select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 a
@@ -1347,10 +1347,10 @@
 4
 explain extended select * from t2 where t2.a in (select a from t1 where t1.b <> 30);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t2	index	a	a	5	NULL	4	100.00	Using index
-1	PRIMARY	t1	ref	a	a	5	test.t2.a	101	100.00	Using where; Using index; FirstMatch(t2)
+1	PRIMARY	t2	index	NULL	a	5	NULL	4	100.00	Using where; Using index
+2	DEPENDENT SUBQUERY	t1	index_subquery	a	a	5	func	1001	100.00	Using index; Using where
 Warnings:
-Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` semi join (`test`.`t1`) where ((`test`.`t1`.`a` = `test`.`t2`.`a`) and (`test`.`t1`.`b` <> 30))
+Note	1003	select `test`.`t2`.`a` AS `a` from `test`.`t2` where <in_optimizer>(`test`.`t2`.`a`,<exists>(<index_lookup>(<cache>(`test`.`t2`.`a`) in t1 on a where ((`test`.`t1`.`b` <> 30) and (<cache>(`test`.`t2`.`a`) = `test`.`t1`.`a`)))))
 drop table t1, t2, t3;
 #
 # alloc_group_fields() working
@@ -2817,10 +2817,10 @@
 Note	1003	select `test`.`t1`.`one` AS `one`,`test`.`t1`.`two` AS `two`,<in_optimizer>((`test`.`t1`.`one`,`test`.`t1`.`two`),<exists>(select `test`.`t2`.`one` AS `one`,`test`.`t2`.`two` AS `two` from `test`.`t2` where ((`test`.`t2`.`flag` = '0') and trigcond(((<cache>(`test`.`t1`.`one`) = `test`.`t2`.`one`) or isnull(`test`.`t2`.`one`))) and trigcond(((<cache>(`test`.`t1`.`two`) = `test`.`t2`.`two`) or isnull(`test`.`t2`.`two`)))) having (trigcond(<is_not_null_test>(`test`.`t2`.`one`)) and trigcond(<is_not_null_test>(`test`.`t2`.`two`))))) AS `test` from `test`.`t1`
 explain extended SELECT one,two from t1 where ROW(one,two) IN (SELECT one,two FROM t2 WHERE flag = 'N');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	8	100.00	Start temporary
-1	PRIMARY	t2	ALL	NULL	NULL	NULL	NULL	9	100.00	Using where; End temporary; Using join buffer
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	8	100.00	Using where
+2	SUBQUERY	t2	ALL	NULL	NULL	NULL	NULL	9	100.00	Using where
 Warnings:
-Note	1003	select `test`.`t1`.`one` AS `one`,`test`.`t1`.`two` AS `two` from `test`.`t1` semi join (`test`.`t2`) where ((`test`.`t2`.`two` = `test`.`t1`.`two`) and (`test`.`t2`.`one` = `test`.`t1`.`one`) and (`test`.`t2`.`flag` = 'N'))
+Note	1003	select `test`.`t1`.`one` AS `one`,`test`.`t1`.`two` AS `two` from `test`.`t1` where <in_optimizer>((`test`.`t1`.`one`,`test`.`t1`.`two`),(`test`.`t1`.`one`,`test`.`t1`.`two`) in ( <materialize> (select `test`.`t2`.`one` AS `one`,`test`.`t2`.`two` AS `two` from `test`.`t2` where (`test`.`t2`.`flag` = 'N') ), <primary_index_lookup>(`test`.`t1`.`one` in <temporary table> on distinct_key)))
 explain extended SELECT one,two,ROW(one,two) IN (SELECT one,two FROM t2 WHERE flag = '0' group by one,two) as 'test' from t1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
 1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	8	100.00	
@@ -4117,31 +4117,39 @@
 INSERT INTO t1 VALUES ('a', 'aaa');
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1);
 a	b
+a	aa
+a	aaa
 CREATE INDEX I1 ON t1 (a);
 CREATE INDEX I2 ON t1 (b);
 EXPLAIN SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	index	I1	I1	7	NULL	#	Using index; LooseScan
-1	PRIMARY	t1	ref	I2	I2	43	test.t1.a	#	Using where
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	#	Using where
+2	SUBQUERY	t1	index	NULL	I1	7	NULL	#	Using index
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1);
 a	b
+a	aa
+a	aaa
 CREATE TABLE t2 (a VARCHAR(1), b VARCHAR(10));
 INSERT INTO t2 SELECT * FROM t1;
 CREATE INDEX I1 ON t2 (a);
 CREATE INDEX I2 ON t2 (b);
 EXPLAIN SELECT a,b FROM t2 WHERE b IN (SELECT a FROM t2);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t2	index	I1	I1	7	NULL	#	Using index; LooseScan
-1	PRIMARY	t2	ref	I2	I2	43	test.t2.a	#	Using where
+1	PRIMARY	t2	ALL	NULL	NULL	NULL	NULL	#	Using where
+2	SUBQUERY	t2	index	NULL	I1	7	NULL	#	Using index
 SELECT a,b FROM t2 WHERE b IN (SELECT a FROM t2);
 a	b
+a	aa
+a	aaa
 EXPLAIN
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1 WHERE LENGTH(a)<500);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	index	I1	I1	7	NULL	#	Using where; Using index; LooseScan
-1	PRIMARY	t1	ref	I2	I2	43	test.t1.a	#	Using where
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	#	Using where
+2	SUBQUERY	t1	index	NULL	I1	7	NULL	#	Using where; Using index
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1 WHERE LENGTH(a)<500);
 a	b
+a	aa
+a	aaa
 DROP TABLE t1,t2;
 #
 # Bug #32400: Complex SELECT query returns correct result only on some

=== modified file 'tests/r/subselect_no_mat_and_semi_join.result'
--- tests/r/subselect_no_mat_and_semi_join.result	2009-06-17 06:23:18 +0000
+++ tests/r/subselect_no_mat_and_semi_join.result	2009-07-28 17:52:18 +0000
@@ -2817,10 +2817,10 @@
 Note	1003	select `test`.`t1`.`one` AS `one`,`test`.`t1`.`two` AS `two`,<in_optimizer>((`test`.`t1`.`one`,`test`.`t1`.`two`),<exists>(select `test`.`t2`.`one` AS `one`,`test`.`t2`.`two` AS `two` from `test`.`t2` where ((`test`.`t2`.`flag` = '0') and trigcond(((<cache>(`test`.`t1`.`one`) = `test`.`t2`.`one`) or isnull(`test`.`t2`.`one`))) and trigcond(((<cache>(`test`.`t1`.`two`) = `test`.`t2`.`two`) or isnull(`test`.`t2`.`two`)))) having (trigcond(<is_not_null_test>(`test`.`t2`.`one`)) and trigcond(<is_not_null_test>(`test`.`t2`.`two`))))) AS `test` from `test`.`t1`
 explain extended SELECT one,two from t1 where ROW(one,two) IN (SELECT one,two FROM t2 WHERE flag = 'N');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	8	100.00	Start temporary
-1	PRIMARY	t2	ALL	NULL	NULL	NULL	NULL	9	100.00	Using where; End temporary; Using join buffer
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	8	100.00	Using where
+2	SUBQUERY	t2	ALL	NULL	NULL	NULL	NULL	9	100.00	Using where
 Warnings:
-Note	1003	select `test`.`t1`.`one` AS `one`,`test`.`t1`.`two` AS `two` from `test`.`t1` semi join (`test`.`t2`) where ((`test`.`t2`.`two` = `test`.`t1`.`two`) and (`test`.`t2`.`one` = `test`.`t1`.`one`) and (`test`.`t2`.`flag` = 'N'))
+Note	1003	select `test`.`t1`.`one` AS `one`,`test`.`t1`.`two` AS `two` from `test`.`t1` where <in_optimizer>((`test`.`t1`.`one`,`test`.`t1`.`two`),(`test`.`t1`.`one`,`test`.`t1`.`two`) in ( <materialize> (select `test`.`t2`.`one` AS `one`,`test`.`t2`.`two` AS `two` from `test`.`t2` where (`test`.`t2`.`flag` = 'N') ), <primary_index_lookup>(`test`.`t1`.`one` in <temporary table> on distinct_key)))
 explain extended SELECT one,two,ROW(one,two) IN (SELECT one,two FROM t2 WHERE flag = '0' group by one,two) as 'test' from t1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
 1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	8	100.00	
@@ -4117,31 +4117,39 @@
 INSERT INTO t1 VALUES ('a', 'aaa');
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1);
 a	b
+a	aa
+a	aaa
 CREATE INDEX I1 ON t1 (a);
 CREATE INDEX I2 ON t1 (b);
 EXPLAIN SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	index	I1	I1	7	NULL	#	Using index; LooseScan
-1	PRIMARY	t1	ref	I2	I2	43	test.t1.a	#	Using where
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	#	Using where
+2	SUBQUERY	t1	index	NULL	I1	7	NULL	#	Using index
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1);
 a	b
+a	aa
+a	aaa
 CREATE TABLE t2 (a VARCHAR(1), b VARCHAR(10));
 INSERT INTO t2 SELECT * FROM t1;
 CREATE INDEX I1 ON t2 (a);
 CREATE INDEX I2 ON t2 (b);
 EXPLAIN SELECT a,b FROM t2 WHERE b IN (SELECT a FROM t2);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t2	index	I1	I1	7	NULL	#	Using index; LooseScan
-1	PRIMARY	t2	ref	I2	I2	43	test.t2.a	#	Using where
+1	PRIMARY	t2	ALL	NULL	NULL	NULL	NULL	#	Using where
+2	SUBQUERY	t2	index	NULL	I1	7	NULL	#	Using index
 SELECT a,b FROM t2 WHERE b IN (SELECT a FROM t2);
 a	b
+a	aa
+a	aaa
 EXPLAIN
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1 WHERE LENGTH(a)<500);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	index	I1	I1	7	NULL	#	Using where; Using index; LooseScan
-1	PRIMARY	t1	ref	I2	I2	43	test.t1.a	#	Using where
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	#	Using where
+2	SUBQUERY	t1	index	NULL	I1	7	NULL	#	Using where; Using index
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1 WHERE LENGTH(a)<500);
 a	b
+a	aa
+a	aaa
 DROP TABLE t1,t2;
 #
 # Bug #32400: Complex SELECT query returns correct result only on some

=== modified file 'tests/r/subselect_no_opts.result'
--- tests/r/subselect_no_opts.result	2009-06-17 06:28:42 +0000
+++ tests/r/subselect_no_opts.result	2009-07-28 17:52:18 +0000
@@ -2817,10 +2817,10 @@
 Note	1003	select `test`.`t1`.`one` AS `one`,`test`.`t1`.`two` AS `two`,<in_optimizer>((`test`.`t1`.`one`,`test`.`t1`.`two`),<exists>(select `test`.`t2`.`one` AS `one`,`test`.`t2`.`two` AS `two` from `test`.`t2` where ((`test`.`t2`.`flag` = '0') and trigcond(((<cache>(`test`.`t1`.`one`) = `test`.`t2`.`one`) or isnull(`test`.`t2`.`one`))) and trigcond(((<cache>(`test`.`t1`.`two`) = `test`.`t2`.`two`) or isnull(`test`.`t2`.`two`)))) having (trigcond(<is_not_null_test>(`test`.`t2`.`one`)) and trigcond(<is_not_null_test>(`test`.`t2`.`two`))))) AS `test` from `test`.`t1`
 explain extended SELECT one,two from t1 where ROW(one,two) IN (SELECT one,two FROM t2 WHERE flag = 'N');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	8	100.00	Start temporary
-1	PRIMARY	t2	ALL	NULL	NULL	NULL	NULL	9	100.00	Using where; End temporary; Using join buffer
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	8	100.00	Using where
+2	SUBQUERY	t2	ALL	NULL	NULL	NULL	NULL	9	100.00	Using where
 Warnings:
-Note	1003	select `test`.`t1`.`one` AS `one`,`test`.`t1`.`two` AS `two` from `test`.`t1` semi join (`test`.`t2`) where ((`test`.`t2`.`two` = `test`.`t1`.`two`) and (`test`.`t2`.`one` = `test`.`t1`.`one`) and (`test`.`t2`.`flag` = 'N'))
+Note	1003	select `test`.`t1`.`one` AS `one`,`test`.`t1`.`two` AS `two` from `test`.`t1` where <in_optimizer>((`test`.`t1`.`one`,`test`.`t1`.`two`),(`test`.`t1`.`one`,`test`.`t1`.`two`) in ( <materialize> (select `test`.`t2`.`one` AS `one`,`test`.`t2`.`two` AS `two` from `test`.`t2` where (`test`.`t2`.`flag` = 'N') ), <primary_index_lookup>(`test`.`t1`.`one` in <temporary table> on distinct_key)))
 explain extended SELECT one,two,ROW(one,two) IN (SELECT one,two FROM t2 WHERE flag = '0' group by one,two) as 'test' from t1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
 1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	8	100.00	
@@ -4117,31 +4117,39 @@
 INSERT INTO t1 VALUES ('a', 'aaa');
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1);
 a	b
+a	aa
+a	aaa
 CREATE INDEX I1 ON t1 (a);
 CREATE INDEX I2 ON t1 (b);
 EXPLAIN SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	index	I1	I1	7	NULL	#	Using index; LooseScan
-1	PRIMARY	t1	ref	I2	I2	43	test.t1.a	#	Using where
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	#	Using where
+2	SUBQUERY	t1	index	NULL	I1	7	NULL	#	Using index
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1);
 a	b
+a	aa
+a	aaa
 CREATE TABLE t2 (a VARCHAR(1), b VARCHAR(10));
 INSERT INTO t2 SELECT * FROM t1;
 CREATE INDEX I1 ON t2 (a);
 CREATE INDEX I2 ON t2 (b);
 EXPLAIN SELECT a,b FROM t2 WHERE b IN (SELECT a FROM t2);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t2	index	I1	I1	7	NULL	#	Using index; LooseScan
-1	PRIMARY	t2	ref	I2	I2	43	test.t2.a	#	Using where
+1	PRIMARY	t2	ALL	NULL	NULL	NULL	NULL	#	Using where
+2	SUBQUERY	t2	index	NULL	I1	7	NULL	#	Using index
 SELECT a,b FROM t2 WHERE b IN (SELECT a FROM t2);
 a	b
+a	aa
+a	aaa
 EXPLAIN
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1 WHERE LENGTH(a)<500);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	index	I1	I1	7	NULL	#	Using where; Using index; LooseScan
-1	PRIMARY	t1	ref	I2	I2	43	test.t1.a	#	Using where
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	#	Using where
+2	SUBQUERY	t1	index	NULL	I1	7	NULL	#	Using where; Using index
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1 WHERE LENGTH(a)<500);
 a	b
+a	aa
+a	aaa
 DROP TABLE t1,t2;
 #
 # Bug #32400: Complex SELECT query returns correct result only on some

=== modified file 'tests/r/subselect_no_semijoin.result'
--- tests/r/subselect_no_semijoin.result	2009-06-17 06:33:28 +0000
+++ tests/r/subselect_no_semijoin.result	2009-07-28 17:52:18 +0000
@@ -2817,10 +2817,10 @@
 Note	1003	select `test`.`t1`.`one` AS `one`,`test`.`t1`.`two` AS `two`,<in_optimizer>((`test`.`t1`.`one`,`test`.`t1`.`two`),<exists>(select `test`.`t2`.`one` AS `one`,`test`.`t2`.`two` AS `two` from `test`.`t2` where ((`test`.`t2`.`flag` = '0') and trigcond(((<cache>(`test`.`t1`.`one`) = `test`.`t2`.`one`) or isnull(`test`.`t2`.`one`))) and trigcond(((<cache>(`test`.`t1`.`two`) = `test`.`t2`.`two`) or isnull(`test`.`t2`.`two`)))) having (trigcond(<is_not_null_test>(`test`.`t2`.`one`)) and trigcond(<is_not_null_test>(`test`.`t2`.`two`))))) AS `test` from `test`.`t1`
 explain extended SELECT one,two from t1 where ROW(one,two) IN (SELECT one,two FROM t2 WHERE flag = 'N');
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	8	100.00	Start temporary
-1	PRIMARY	t2	ALL	NULL	NULL	NULL	NULL	9	100.00	Using where; End temporary; Using join buffer
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	8	100.00	Using where
+2	SUBQUERY	t2	ALL	NULL	NULL	NULL	NULL	9	100.00	Using where
 Warnings:
-Note	1003	select `test`.`t1`.`one` AS `one`,`test`.`t1`.`two` AS `two` from `test`.`t1` semi join (`test`.`t2`) where ((`test`.`t2`.`two` = `test`.`t1`.`two`) and (`test`.`t2`.`one` = `test`.`t1`.`one`) and (`test`.`t2`.`flag` = 'N'))
+Note	1003	select `test`.`t1`.`one` AS `one`,`test`.`t1`.`two` AS `two` from `test`.`t1` where <in_optimizer>((`test`.`t1`.`one`,`test`.`t1`.`two`),(`test`.`t1`.`one`,`test`.`t1`.`two`) in ( <materialize> (select `test`.`t2`.`one` AS `one`,`test`.`t2`.`two` AS `two` from `test`.`t2` where (`test`.`t2`.`flag` = 'N') ), <primary_index_lookup>(`test`.`t1`.`one` in <temporary table> on distinct_key)))
 explain extended SELECT one,two,ROW(one,two) IN (SELECT one,two FROM t2 WHERE flag = '0' group by one,two) as 'test' from t1;
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
 1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	8	100.00	
@@ -4117,31 +4117,39 @@
 INSERT INTO t1 VALUES ('a', 'aaa');
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1);
 a	b
+a	aa
+a	aaa
 CREATE INDEX I1 ON t1 (a);
 CREATE INDEX I2 ON t1 (b);
 EXPLAIN SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	index	I1	I1	7	NULL	#	Using index; LooseScan
-1	PRIMARY	t1	ref	I2	I2	43	test.t1.a	#	Using where
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	#	Using where
+2	SUBQUERY	t1	index	NULL	I1	7	NULL	#	Using index
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1);
 a	b
+a	aa
+a	aaa
 CREATE TABLE t2 (a VARCHAR(1), b VARCHAR(10));
 INSERT INTO t2 SELECT * FROM t1;
 CREATE INDEX I1 ON t2 (a);
 CREATE INDEX I2 ON t2 (b);
 EXPLAIN SELECT a,b FROM t2 WHERE b IN (SELECT a FROM t2);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t2	index	I1	I1	7	NULL	#	Using index; LooseScan
-1	PRIMARY	t2	ref	I2	I2	43	test.t2.a	#	Using where
+1	PRIMARY	t2	ALL	NULL	NULL	NULL	NULL	#	Using where
+2	SUBQUERY	t2	index	NULL	I1	7	NULL	#	Using index
 SELECT a,b FROM t2 WHERE b IN (SELECT a FROM t2);
 a	b
+a	aa
+a	aaa
 EXPLAIN
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1 WHERE LENGTH(a)<500);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	index	I1	I1	7	NULL	#	Using where; Using index; LooseScan
-1	PRIMARY	t1	ref	I2	I2	43	test.t1.a	#	Using where
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	#	Using where
+2	SUBQUERY	t1	index	NULL	I1	7	NULL	#	Using where; Using index
 SELECT a,b FROM t1 WHERE b IN (SELECT a FROM t1 WHERE LENGTH(a)<500);
 a	b
+a	aa
+a	aaa
 DROP TABLE t1,t2;
 #
 # Bug #32400: Complex SELECT query returns correct result only on some

=== modified file 'tests/r/subselect_sj.result'
--- tests/r/subselect_sj.result	2009-01-30 21:02:37 +0000
+++ tests/r/subselect_sj.result	2009-07-28 17:52:18 +0000
@@ -12,8 +12,8 @@
 Flattened because of dependency, t10=func(t1)
 explain select * from t1 where a in (select pk from t10);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	3	
-1	PRIMARY	t10	eq_ref	PRIMARY	PRIMARY	4	test.t1.a	1	Using index
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	3	Using where
+2	SUBQUERY	t10	index	NULL	PRIMARY	4	NULL	10	Using index
 select * from t1 where a in (select pk from t10);
 a	b
 0	0
@@ -22,22 +22,22 @@
 A confluent case of dependency
 explain select * from t1 where a in (select a from t10 where pk=12);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	3	
-1	PRIMARY	t10	const	PRIMARY	PRIMARY	4	const	1	Using where
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	3	Using where
+2	SUBQUERY	NULL	NULL	NULL	NULL	NULL	NULL	NULL	Impossible WHERE noticed after reading const tables
 select * from t1 where a in (select a from t10 where pk=12);
 a	b
 An empty table inside
 explain select * from t1 where a in (select a from t11);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t11	ALL	NULL	NULL	NULL	NULL	1	Start temporary
-1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	3	Using where; End temporary; Using join buffer
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	3	Using where
+2	SUBQUERY	t11	ALL	NULL	NULL	NULL	NULL	1	
 select * from t1 where a in (select a from t11);
 a	b
 explain select * from t1 where a in (select pk from t10) and b in (select pk from t10);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	3	
-1	PRIMARY	t10	eq_ref	PRIMARY	PRIMARY	4	test.t1.a	1	Using index
-1	PRIMARY	t10	eq_ref	PRIMARY	PRIMARY	4	test.t1.b	1	Using index
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	3	Using where
+3	SUBQUERY	t10	index	NULL	PRIMARY	4	NULL	10	Using index
+2	SUBQUERY	t10	index	NULL	PRIMARY	4	NULL	10	Using index
 select * from t1 where a in (select pk from t10) and b in (select pk from t10);
 a	b
 0	0
@@ -46,9 +46,9 @@
 flattening a nested subquery
 explain select * from t1 where a in (select pk from t10 where t10.a in (select pk from t12));
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	3	
-1	PRIMARY	t10	eq_ref	PRIMARY	PRIMARY	4	test.t1.a	1	
-1	PRIMARY	t12	eq_ref	PRIMARY	PRIMARY	4	test.t10.a	1	Using index
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	3	Using where
+2	SUBQUERY	t10	ALL	NULL	NULL	NULL	NULL	10	Using where
+3	SUBQUERY	t12	index	NULL	PRIMARY	4	NULL	10	Using index
 select * from t1 where a in (select pk from t10 where t10.a in (select pk from t12));
 a	b
 0	0
@@ -57,21 +57,25 @@
 flattening subquery w/ several tables
 explain extended select * from t1 where a in (select t10.pk from t10, t12 where t12.pk=t10.a);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
-1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	3	100.00	
-1	PRIMARY	t10	eq_ref	PRIMARY	PRIMARY	4	test.t1.a	1	100.00	
-1	PRIMARY	t12	eq_ref	PRIMARY	PRIMARY	4	test.t10.a	1	100.00	Using index
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	3	100.00	Using where
+2	SUBQUERY	t10	ALL	NULL	NULL	NULL	NULL	10	100.00	
+2	SUBQUERY	t12	eq_ref	PRIMARY	PRIMARY	4	test.t10.a	1	100.00	Using index
 Warnings:
-Note	1003	select `test`.`t1`.`a` AS `a`,`test`.`t1`.`b` AS `b` from (`test`.`t10` join `test`.`t12`) join `test`.`t1` where ((`test`.`t10`.`pk` = `test`.`t1`.`a`) and (`test`.`t12`.`pk` = `test`.`t10`.`a`))
+Note	1003	select `test`.`t1`.`a` AS `a`,`test`.`t1`.`b` AS `b` from `test`.`t1` where <in_optimizer>(`test`.`t1`.`a`,`test`.`t1`.`a` in ( <materialize> (select `test`.`t10`.`pk` AS `pk` from `test`.`t10` join `test`.`t12` where (`test`.`t12`.`pk` = `test`.`t10`.`a`) ), <primary_index_lookup>(`test`.`t1`.`a` in <temporary table> on distinct_key)))
 subqueries within outer joins go into ON expr.
 select * from
 t1 left join t2 on (t2.a= t1.a and t2.a in (select pk from t10)) 
 where t1.a < 5;
+a	b	a	b
+0	0	0	0
+1	1	1	1
+2	2	2	2
 insert into t1 select (A.a + 10 * B.a),1 from t0 A, t0 B;
 explain extended select * from t1 where a in (select pk from t10 where pk<3);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	filtered	Extra
 1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	103	100.00	Using where
-1	PRIMARY	t10	eq_ref	PRIMARY	PRIMARY	4	test.t1.a	1	100.00	Using index
+2	SUBQUERY	t10	range	PRIMARY	PRIMARY	4	NULL	3	100.00	Using where; Using index
 Warnings:
-Note	1003	select `test`.`t1`.`a` AS `a`,`test`.`t1`.`b` AS `b` from (`test`.`t10`) join `test`.`t1` where ((`test`.`t10`.`pk` = `test`.`t1`.`a`) and (`test`.`t1`.`a` < 3))
+Note	1003	select `test`.`t1`.`a` AS `a`,`test`.`t1`.`b` AS `b` from `test`.`t1` where <in_optimizer>(`test`.`t1`.`a`,`test`.`t1`.`a` in ( <materialize> (select `test`.`t10`.`pk` AS `pk` from `test`.`t10` where (`test`.`t10`.`pk` < 3) ), <primary_index_lookup>(`test`.`t1`.`a` in <temporary table> on distinct_key)))
 drop table t0, t1;
 drop table t10, t11, t12;

=== modified file 'tests/r/subselect_sj2.result'
--- tests/r/subselect_sj2.result	2009-03-11 01:16:44 +0000
+++ tests/r/subselect_sj2.result	2009-07-29 07:11:15 +0000
@@ -31,8 +31,8 @@
 9	5
 explain select * from t2 where b in (select a from t1);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	3	Start temporary
-1	PRIMARY	t2	ref	b	b	5	test.t1.a	1	End temporary
+1	PRIMARY	t2	ALL	NULL	NULL	NULL	NULL	10	Using where
+2	SUBQUERY	t1	ALL	NULL	NULL	NULL	NULL	3	
 select * from t2 where b in (select a from t1);
 a	b
 1	1
@@ -49,8 +49,8 @@
 insert into t3 select a,a, a,a,a from t0;
 explain select * from t3 where b in (select a from t1);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	3	Start temporary
-1	PRIMARY	t3	ref	b	b	5	test.t1.a	1	End temporary
+1	PRIMARY	t3	ALL	NULL	NULL	NULL	NULL	10	Using where
+2	SUBQUERY	t1	ALL	NULL	NULL	NULL	NULL	3	
 select * from t3 where b in (select a from t1);
 a	b	pk1	pk2	pk3
 1	1	1	1	1
@@ -71,12 +71,16 @@
 from t0 A, t0 B where B.a <5;
 explain select * from t3 where b in (select a from t0);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t0	ALL	NULL	NULL	NULL	NULL	10	Start temporary
-1	PRIMARY	t3	ref	b	b	5	test.t0.a	1	End temporary
+1	PRIMARY	t3	ALL	NULL	NULL	NULL	NULL	50	Using where
+2	SUBQUERY	t0	ALL	NULL	NULL	NULL	NULL	10	
 select * from t3 where b in (select A.a+B.a from t0 A, t0 B where B.a<5);
 a	b	pk1	pk2
 0	0	0	0
 1	1	1	1
+10	10	10	10
+11	11	11	11
+12	12	12	12
+13	13	13	13
 2	2	2	2
 3	3	3	3
 4	4	4	4
@@ -85,16 +89,12 @@
 7	7	7	7
 8	8	8	8
 9	9	9	9
-10	10	10	10
-11	11	11	11
-12	12	12	12
-13	13	13	13
 set join_buffer_size= @save_join_buffer_size;
 set max_heap_table_size= @save_max_heap_table_size;
 explain select * from t1 where a in (select b from t2);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	3	
-1	PRIMARY	t2	ref	b	b	5	test.t1.a	1	Using index; FirstMatch(t1)
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	3	Using where
+2	SUBQUERY	t2	index	NULL	b	5	NULL	10	Using index
 select * from t1;
 a	b
 1	1
@@ -123,8 +123,8 @@
 a, mid(filler1, 1,10), length(filler1)=length(filler2) as Z 
 from t1 t0 where a in (select a from t2 it);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	it	ALL	NULL	NULL	NULL	NULL	22	Start temporary
-1	PRIMARY	t0	ALL	NULL	NULL	NULL	NULL	32	Using where; End temporary; Using join buffer
+1	PRIMARY	t0	ALL	NULL	NULL	NULL	NULL	32	Using where
+2	SUBQUERY	it	ALL	NULL	NULL	NULL	NULL	22	
 select 
 a, mid(filler1, 1,10), length(filler1)=length(filler2) as Z 
 from t1 t0 where a in (select a from t2 it);
@@ -155,8 +155,8 @@
 a, mid(filler1, 1,10), length(filler1)=length(filler2) 
 from t2 t0 where a in (select a from t1 it);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t0	ALL	NULL	NULL	NULL	NULL	22	Start temporary
-1	PRIMARY	it	ALL	NULL	NULL	NULL	NULL	32	Using where; End temporary; Using join buffer
+1	PRIMARY	t0	ALL	NULL	NULL	NULL	NULL	22	Using where
+2	SUBQUERY	it	ALL	NULL	NULL	NULL	NULL	32	
 select 
 a, mid(filler1, 1,10), length(filler1)=length(filler2) 
 from t2 t0 where a in (select a from t1 it);
@@ -165,23 +165,23 @@
 1	filler1234	1
 2	filler1234	1
 3	filler1234	1
+4	filler1234	1
+5	filler1234	1
+6	filler1234	1
+7	filler1234	1
+8	filler1234	1
+9	filler1234	1
+10	filler1234	1
+11	filler1234	1
+12	filler1234	1
+13	filler1234	1
+14	filler1234	1
+15	filler1234	1
+16	filler1234	1
+17	filler1234	1
+18	filler1234	1
+19	filler1234	1
 3	duplicate 	1
-4	filler1234	1
-5	filler1234	1
-6	filler1234	1
-7	filler1234	1
-8	filler1234	1
-9	filler1234	1
-10	filler1234	1
-11	filler1234	1
-12	filler1234	1
-13	filler1234	1
-14	filler1234	1
-15	filler1234	1
-16	filler1234	1
-17	filler1234	1
-18	filler1234	1
-19	filler1234	1
 19	duplicate 	1
 insert into t1 select a+20, 'filler123456', 'filler123456' from t0;
 insert into t1 select a+20, 'filler123456', 'filler123456' from t0;
@@ -189,8 +189,8 @@
 a, mid(filler1, 1,10), length(filler1)=length(filler2) as Z 
 from t1 t0 where a in (select a from t2 it);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	it	ALL	NULL	NULL	NULL	NULL	22	Start temporary
-1	PRIMARY	t0	ALL	NULL	NULL	NULL	NULL	52	Using where; End temporary; Using join buffer
+1	PRIMARY	t0	ALL	NULL	NULL	NULL	NULL	52	Using where
+2	SUBQUERY	it	ALL	NULL	NULL	NULL	NULL	22	
 select 
 a, mid(filler1, 1,10), length(filler1)=length(filler2) as Z 
 from t1 t0 where a in (select a from t2 it);
@@ -221,8 +221,8 @@
 a, mid(filler1, 1,10), length(filler1)=length(filler2) 
 from t2 t0 where a in (select a from t1 it);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t0	ALL	NULL	NULL	NULL	NULL	22	Start temporary
-1	PRIMARY	it	ALL	NULL	NULL	NULL	NULL	52	Using where; End temporary; Using join buffer
+1	PRIMARY	t0	ALL	NULL	NULL	NULL	NULL	22	Using where
+2	SUBQUERY	it	ALL	NULL	NULL	NULL	NULL	52	
 select 
 a, mid(filler1, 1,10), length(filler1)=length(filler2) 
 from t2 t0 where a in (select a from t1 it);
@@ -231,23 +231,23 @@
 1	filler1234	1
 2	filler1234	1
 3	filler1234	1
+4	filler1234	1
+5	filler1234	1
+6	filler1234	1
+7	filler1234	1
+8	filler1234	1
+9	filler1234	1
+10	filler1234	1
+11	filler1234	1
+12	filler1234	1
+13	filler1234	1
+14	filler1234	1
+15	filler1234	1
+16	filler1234	1
+17	filler1234	1
+18	filler1234	1
+19	filler1234	1
 3	duplicate 	1
-4	filler1234	1
-5	filler1234	1
-6	filler1234	1
-7	filler1234	1
-8	filler1234	1
-9	filler1234	1
-10	filler1234	1
-11	filler1234	1
-12	filler1234	1
-13	filler1234	1
-14	filler1234	1
-15	filler1234	1
-16	filler1234	1
-17	filler1234	1
-18	filler1234	1
-19	filler1234	1
 19	duplicate 	1
 drop table t1, t2;
 create table t1 (a int, b int, key(a));
@@ -261,10 +261,10 @@
 from t0 where a in
 (select t2.a+t3.a from t1 left join (t2 join t3) on t2.a=t1.a and t3.a=t1.a);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t0	ALL	NULL	NULL	NULL	NULL	10	Start temporary
-1	PRIMARY	t1	index	NULL	a	5	NULL	10	Using index; Using join buffer
-1	PRIMARY	t2	ref	a	a	5	test.t1.a	1	Using index
-1	PRIMARY	t3	ref	a	a	5	test.t1.a	1	Using where; Using index; End temporary
+1	PRIMARY	t0	ALL	NULL	NULL	NULL	NULL	10	Using where
+2	SUBQUERY	t1	index	NULL	a	5	NULL	10	Using index
+2	SUBQUERY	t2	ref	a	a	5	test.t1.a	1	Using index
+2	SUBQUERY	t3	ref	a	a	5	test.t1.a	1	Using index
 drop table t0, t1,t2,t3;
 CREATE TABLE t1 (
 ID int NOT NULL auto_increment,
@@ -300,9 +300,9 @@
 WHERE Language='English' AND Percentage > 10 AND
 t2.Population > 100000);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t2	ALL	PRIMARY,Population	NULL	NULL	NULL	16	Using where
-1	PRIMARY	t3	eq_ref	PRIMARY,Percentage	PRIMARY	136	test.t2.Code,const	1	Using where
-1	PRIMARY	t1	ref	Population,Country	Country	14	test.t2.Code	1	Using where; FirstMatch(t3)
+1	PRIMARY	t2	ALL	NULL	NULL	NULL	NULL	16	Using where
+3	DEPENDENT SUBQUERY	t3	unique_subquery	PRIMARY,Percentage	PRIMARY	136	func,const	1	Using where
+2	SUBQUERY	t1	range	Population	Population	4	NULL	1	Using where
 DROP TABLE t1,t2,t3;
 CREATE TABLE t1 (
 Code char(3) NOT NULL DEFAULT '',
@@ -336,8 +336,8 @@
 WHERE t1.Code IN (
 SELECT t2.CountryCode FROM t2 WHERE Population > 5000000);
 id	select_type	table	type	possible_keys	key	key_len	ref	rows	Extra
-1	PRIMARY	t1	ALL	PRIMARY	NULL	NULL	NULL	31	
-1	PRIMARY	t2	ref	CountryCode	CountryCode	14	test.t1.Code	1	Using where; FirstMatch(t1)
+1	PRIMARY	t1	ALL	NULL	NULL	NULL	NULL	31	Using where
+2	SUBQUERY	t2	ALL	NULL	NULL	NULL	NULL	125	Using where
 SELECT Name FROM t1 
 WHERE t1.Code IN (
 SELECT t2.CountryCode FROM t2 WHERE Population > 5000000);

